# BoundaryValueDiffEq

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/BoundaryValueDiffEq/dev/)

[![Build Status](https://github.com/SciML/BoundaryValueDiffEq.jl/workflows/CI/badge.svg)](https://github.com/SciML/BoundaryValueDiffEq.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/SciML/BoundaryValueDiffEq.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/BoundaryValueDiffEq.jl)
[![Package Downloads](https://shields.io/endpoint?url=https://pkgs.genieframework.com/api/v1/badge/BoundaryValueDiffEq)](https://pkgs.genieframework.com?packages=BoundaryValueDiffEq)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

BoundaryValueDiffEq.jl is a component package in the DifferentialEquations ecosystem. It holds the
boundary value problem solvers and utilities. While completely independent
and usable on its own, users interested in using this
functionality should check out [DifferentialEquations.jl](https://github.com/JuliaDiffEq/DifferentialEquations.jl).

## API

BoundaryValueDiffEq.jl is part of the SciML common interface, but can be used independently of DifferentialEquations.jl. The only requirement is that the user passes a BoundaryValueDiffEq.jl algorithm to solve. For example, we can solve the [BVP tutorial from the documentation](https://docs.sciml.ai/DiffEqDocs/stable/tutorials/bvp_example/) using the `MIRK4()` algorithm:

```julia
using BoundaryValueDiffEq
tspan = (0.0, pi / 2)
function simplependulum!(du, u, p, t)
    θ = u[1]
    dθ = u[2]
    du[1] = dθ
    du[2] = -9.81 * sin(θ)
end
function bc!(residual, u, p, t)
    residual[1] = u(pi / 4)[1] + pi / 2
    residual[2] = u(pi / 2)[1] - pi / 2
end
prob = BVProblem(simplependulum!, bc!, [pi / 2, pi / 2], tspan)
sol = solve(prob, MIRK4(), dt = 0.05)
```

## Available Solvers

For the list of available solvers, please refer to the [DifferentialEquations.jl BVP Solvers page](https://docs.sciml.ai/DiffEqDocs/stable/solvers/bvp_solve/). For options for the `solve` command, see the [common solver options page](https://docs.sciml.ai/DiffEqDocs/stable/basics/common_solver_opts/).

## Controlling Precompilation

Precompilation can be controlled via `Preferences.jl`

  - `PrecompileMIRK` -- Precompile the MIRK2 - MIRK6 algorithms (default: `true`).
  - `PrecompileShooting` -- Precompile the single shooting algorithms (default: `true`).
  - `PrecompileMultipleShooting` -- Precompile the multiple shooting algorithms (default: `true`).
  - `PrecompileMIRKNLLS` -- Precompile the MIRK2 - MIRK6 algorithms for under-determined and over-determined BVPs (default: `false`).
  - `PrecompileShootingNLLS` -- Precompile the single shooting algorithms for under-determined and over-determined BVPs (default: `true`).
  - `PrecompileMultipleShootingNLLS` -- Precompile the multiple shooting algorithms for under-determined and over-determined BVPs (default: `true` ).

To set these preferences before loading the package, do the following (replacing `PrecompileShooting` with the preference you want to set, or pass in multiple pairs to set them together):

```julia
using Preferences, UUIDs
Preferences.set_preferences!(UUID("764a87c0-6b3e-53db-9096-fe964310641d"), "PrecompileShooting" => false)
```

## Running Benchmarks Locally

We include a small set of benchmarks in the `benchmarks` folder. These are not extensive and mainly used to track regressions during development. For more extensive benchmarks, see the [SciMLBenchmarks](https://github.com/SciML/SciMLBenchmarks.jl) repository.

To run benchmarks locally install [AirspeedVelocity.jl](https://github.com/MilesCranmer/AirspeedVelocity.jl) and run the following command in the package directory:

```bash
benchpkg BoundaryValueDiffEq --rev="master,<git sha for your commit>" --bench-on="master"
```

@testitem "Verbose field in caches" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: @SciMLMessage, SciMLLogging

    # Simple pendulum problem for testing
    tspan = (0.0, pi / 2)
    function simplependulum!(du, u, p, t)
        θ = u[1]
        dθ = u[2]
        du[1] = dθ
        du[2] = -9.81 * sin(θ)
    end
    function bc!(residual, u, p, t)
        residual[1] = u(pi / 4)[1] + pi / 2
        residual[2] = u(pi / 2)[1] - pi / 2
    end
    u0 = [pi / 2, pi / 2]
    prob = BVProblem(simplependulum!, bc!, u0, tspan)

    # Test MIRK with default verbose
    @testset "MIRK default verbose" begin
        cache = init(prob, MIRK4(), dt = 0.05)
        @test cache.verbose isa BVPVerbosity
        @test cache.verbose == BVPVerbosity()  # Default should be Standard preset
    end

    # Test MIRK with verbose = false
    @testset "MIRK verbose = false" begin
        cache = init(prob, MIRK4(), dt = 0.05, verbose = false)
        @test cache.verbose isa BVPVerbosity
        @test cache.verbose == BVPVerbosity(SciMLLogging.None())
    end

    # Test MIRK with verbose = true
    @testset "MIRK verbose = true" begin
        cache = init(prob, MIRK4(), dt = 0.05, verbose = true)
        @test cache.verbose isa BVPVerbosity
        @test cache.verbose == BVPVerbosity()  # true should give Standard preset
    end

    # Test MIRK with BVPVerbosity preset
    @testset "MIRK verbose = BVPVerbosity(Detailed())" begin
        cache = init(prob, MIRK4(), dt = 0.05, verbose = BVPVerbosity(SciMLLogging.Detailed()))
        @test cache.verbose isa BVPVerbosity
        @test cache.verbose == BVPVerbosity(SciMLLogging.Detailed())
    end

    # Test FIRK (nested) with verbose
    @testset "FIRK nested verbose" begin
        cache = init(prob, LobattoIIIa4(nested_nlsolve = true), dt = 0.05)
        @test cache.verbose isa BVPVerbosity

        cache_false = init(prob, LobattoIIIa4(nested_nlsolve = true), dt = 0.05, verbose = false)
        @test cache_false.verbose == BVPVerbosity(SciMLLogging.None())
    end

    # Test FIRK (expanded) with verbose
    @testset "FIRK expanded verbose" begin
        cache = init(prob, LobattoIIIa4(nested_nlsolve = false), dt = 0.05)
        @test cache.verbose isa BVPVerbosity

        cache_false = init(prob, LobattoIIIa4(nested_nlsolve = false), dt = 0.05, verbose = false)
        @test cache_false.verbose == BVPVerbosity(SciMLLogging.None())
    end

    # Test __split_kwargs with verbose
    @testset "__split_kwargs verbose extraction" begin
        using BoundaryValueDiffEqCore: __split_kwargs, DEFAULT_VERBOSE

        # Test with default verbose
        (abstol, adaptive, controller, verbose), remaining = __split_kwargs(
            abstol = 1.0e-6, adaptive = true, controller = DefectControl()
        )
        @test abstol == 1.0e-6
        @test adaptive == true
        @test controller isa DefectControl
        @test verbose == DEFAULT_VERBOSE

        # Test with custom verbose
        custom_verbose = BVPVerbosity(SciMLLogging.None())
        (abstol, adaptive, controller, verbose), remaining = __split_kwargs(
            abstol = 1.0e-4, adaptive = false, controller = NoErrorControl(),
            verbose = custom_verbose
        )
        @test abstol == 1.0e-4
        @test adaptive == false
        @test controller isa NoErrorControl
        @test verbose == custom_verbose
    end
end

@testitem "Verbose field in MIRKN cache" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: @SciMLMessage, SciMLLogging

    # Second order BVP for MIRKN
    tspan = (0.0, 1.0)
    function f!(ddu, du, u, p, t)
        ddu[1] = -u[1]
    end
    function bc!(res, du, u, p, t)
        res[1] = u[1][1]
        res[2] = u[end][1] - 1
    end
    u0 = [0.0]
    prob = SecondOrderBVProblem(f!, bc!, u0, tspan)

    # Test MIRKN with default verbose
    @testset "MIRKN default verbose" begin
        cache = init(prob, MIRKN4(), dt = 0.1)
        @test cache.verbose isa BVPVerbosity
        @test cache.verbose == BVPVerbosity()
    end

    # Test MIRKN with verbose = false
    @testset "MIRKN verbose = false" begin
        cache = init(prob, MIRKN4(), dt = 0.1, verbose = false)
        @test cache.verbose == BVPVerbosity(SciMLLogging.None())
    end

    # Test MIRKN with custom verbose
    @testset "MIRKN custom verbose" begin
        cache = init(prob, MIRKN4(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.All()))
        @test cache.verbose == BVPVerbosity(SciMLLogging.All())
    end
end

@testitem "Verbose persistence through solve" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: @SciMLMessage, SciMLLogging

    # Simple test problem
    tspan = (0.0, 1.0)
    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
    end
    function bc!(res, u, p, t)
        res[1] = u[1][1]
        res[2] = u[end][1] - 1
    end
    u0 = [0.0, 1.0]
    prob = BVProblem(f!, bc!, u0, tspan)

    # Test that verbose setting persists through the solve
    @testset "Verbose persists in MIRK solve" begin
        sol = solve(prob, MIRK4(), dt = 0.1, verbose = false)
        @test SciMLBase.successful_retcode(sol)
    end

    @testset "Verbose persists in FIRK solve" begin
        sol = solve(prob, RadauIIa5(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.None()))
        @test SciMLBase.successful_retcode(sol)
    end

    @testset "Verbose with All preset" begin
        # This should work without errors even with maximum verbosity
        sol = solve(prob, MIRK4(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.All()))
        @test SciMLBase.successful_retcode(sol)
    end
end

@testitem "Internal solver verbosity integration" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: SciMLLogging

    # Test BVPVerbosity has both verbosity fields
    @testset "Verbosity fields exist" begin
        v = BVPVerbosity()
        @test hasfield(typeof(v), :nonlinear_verbosity)
        @test hasfield(typeof(v), :optimization_verbosity)
        @test v.nonlinear_verbosity == SciMLLogging.Standard()
        @test v.optimization_verbosity == SciMLLogging.Standard()
    end

    # Test preset matching for both verbosity controls
    @testset "Preset matching" begin
        v_none = BVPVerbosity(SciMLLogging.None())
        @test v_none.nonlinear_verbosity == SciMLLogging.None()
        @test v_none.optimization_verbosity == SciMLLogging.None()

        v_detailed = BVPVerbosity(SciMLLogging.Detailed())
        @test v_detailed.nonlinear_verbosity == SciMLLogging.Detailed()
        @test v_detailed.optimization_verbosity == SciMLLogging.Detailed()

        v_all = BVPVerbosity(SciMLLogging.All())
        @test v_all.nonlinear_verbosity == SciMLLogging.All()
        @test v_all.optimization_verbosity == SciMLLogging.All()
    end

    # Test that Standard preset sets appropriate verbosity
    @testset "Standard preset verbosity" begin
        v = BVPVerbosity(SciMLLogging.Standard())
        @test v.bvpsol_convergence == SciMLLogging.WarnLevel()
        @test v.nonlinear_verbosity == SciMLLogging.Standard()
        @test v.optimization_verbosity == SciMLLogging.Standard()
    end

    # Test integration with solve - verify it doesn't error
    @testset "Solve with different verbosity presets" begin
        tspan = (0.0, 1.0)
        function f!(du, u, p, t)
            du[1] = u[2]
            du[2] = -u[1]
        end
        function bc!(res, u, p, t)
            res[1] = u[1][1]
            res[2] = u[end][1] - 1
        end
        u0 = [0.0, 1.0]
        prob = BVProblem(f!, bc!, u0, tspan)

        # Test with All preset
        sol = solve(
            prob, MIRK4(), dt = 0.1,
            verbose = BVPVerbosity(SciMLLogging.All())
        )
        @test SciMLBase.successful_retcode(sol)

        # Test with None preset
        sol = solve(
            prob, RadauIIa5(), dt = 0.1,
            verbose = BVPVerbosity(SciMLLogging.None())
        )
        @test SciMLBase.successful_retcode(sol)

        # Test with MIRKN
        tspan2 = (0.0, 1.0)
        function f2!(ddu, du, u, p, t)
            ddu[1] = -u[1]
        end
        function bc2!(res, du, u, p, t)
            res[1] = u[1][1]
            res[2] = u[end][1] - 1
        end
        u0_2 = [0.0]
        prob2 = SecondOrderBVProblem(f2!, bc2!, u0_2, tspan2)

        sol2 = solve(
            prob2, MIRKN4(), dt = 0.1,
            verbose = BVPVerbosity(SciMLLogging.Detailed())
        )
        @test SciMLBase.successful_retcode(sol2)
    end
end

@testitem "Verbosity propagation via cache inspection" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: __concrete_kwargs, SciMLLogging
    using NonlinearSolveFirstOrder: NewtonRaphson
    using NonlinearSolveBase: NonlinearVerbosity
    using OptimizationBase: OptimizationVerbosity

    # Simple test problem
    tspan = (0.0, 1.0)
    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
    end
    function bc!(res, u, p, t)
        res[1] = u[1][1]
        res[2] = u[end][1] - 1
    end
    u0 = [0.0, 1.0]
    prob = BVProblem(f!, bc!, u0, tspan)

    # Test MIRK with NonlinearSolve verbosity
    @testset "MIRK cache NonlinearSolve verbosity" begin
        # Init with All verbosity
        cache = init(prob, MIRK4(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.All()))

        # Extract what would be passed to internal solver
        kwargs = __concrete_kwargs(
            cache.alg.nlsolve, cache.alg.optimize,
            cache.nlsolve_kwargs, cache.optimize_kwargs,
            cache.verbose
        )

        @test haskey(kwargs, :verbose)
        @test kwargs.verbose isa NonlinearVerbosity

        # Init with None verbosity
        cache_none = init(prob, MIRK4(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.None()))
        kwargs_none = __concrete_kwargs(
            cache_none.alg.nlsolve, cache_none.alg.optimize,
            cache_none.nlsolve_kwargs, cache_none.optimize_kwargs,
            cache_none.verbose
        )

        @test haskey(kwargs_none, :verbose)
        @test kwargs_none.verbose isa NonlinearVerbosity
    end

    # Test FIRK with NonlinearSolve verbosity
    @testset "FIRK cache NonlinearSolve verbosity" begin
        cache = init(prob, RadauIIa5(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.Detailed()))

        kwargs = __concrete_kwargs(
            cache.alg.nlsolve, cache.alg.optimize,
            cache.nlsolve_kwargs, cache.optimize_kwargs,
            cache.verbose
        )

        @test haskey(kwargs, :verbose)
        @test kwargs.verbose isa NonlinearVerbosity
    end

    # Test MIRKN with NonlinearSolve verbosity
    @testset "MIRKN cache NonlinearSolve verbosity" begin
        tspan2 = (0.0, 1.0)
        function f2!(ddu, du, u, p, t)
            ddu[1] = -u[1]
        end
        function bc2!(res, du, u, p, t)
            res[1] = u[1][1]
            res[2] = u[end][1] - 1
        end
        u0_2 = [0.0]
        prob2 = SecondOrderBVProblem(f2!, bc2!, u0_2, tspan2)

        cache = init(prob2, MIRKN4(), dt = 0.1, verbose = BVPVerbosity(SciMLLogging.Standard()))

        kwargs = __concrete_kwargs(
            cache.alg.nlsolve, cache.alg.optimize,
            cache.nlsolve_kwargs, cache.optimize_kwargs,
            cache.verbose
        )

        @test haskey(kwargs, :verbose)
        @test kwargs.verbose isa NonlinearVerbosity
    end

    # Test with explicit nlsolve algorithm
    @testset "Explicit nlsolve algorithm verbosity" begin
        cache = init(
            prob, MIRK4(nlsolve = NewtonRaphson()), dt = 0.1,
            verbose = BVPVerbosity(SciMLLogging.All())
        )

        kwargs = __concrete_kwargs(
            cache.alg.nlsolve, cache.alg.optimize,
            cache.nlsolve_kwargs, cache.optimize_kwargs,
            cache.verbose
        )

        @test haskey(kwargs, :verbose)
        @test kwargs.verbose isa NonlinearVerbosity
    end

    # Test user-specified verbose takes precedence
    @testset "User nlsolve_kwargs verbose precedence" begin
        user_verbose = NonlinearVerbosity(SciMLLogging.Minimal())
        cache = init(
            prob, MIRK4(), dt = 0.1,
            verbose = BVPVerbosity(SciMLLogging.All()),
            nlsolve_kwargs = (; verbose = user_verbose)
        )

        kwargs = __concrete_kwargs(
            cache.alg.nlsolve, cache.alg.optimize,
            cache.nlsolve_kwargs, cache.optimize_kwargs,
            cache.verbose
        )

        @test kwargs.verbose === user_verbose
    end

    # Test OptimizationVerbosity extraction (mock optimization algorithm)
    @testset "OptimizationVerbosity extraction" begin
        # We can't easily test with a real optimization algorithm without adding dependencies
        # But we can test the __concrete_kwargs function directly with a mock optimize value
        bvp_verbose = BVPVerbosity(SciMLLogging.All())
        mock_opt_alg = :some_optimizer

        kwargs = __concrete_kwargs(
            nothing, mock_opt_alg,
            (;), (;),
            bvp_verbose
        )

        @test haskey(kwargs, :verbose)
        @test kwargs.verbose isa OptimizationVerbosity

        # Test with None preset
        bvp_verbose_none = BVPVerbosity(SciMLLogging.None())
        kwargs_none = __concrete_kwargs(
            nothing, mock_opt_alg,
            (;), (;),
            bvp_verbose_none
        )

        @test haskey(kwargs_none, :verbose)
        @test kwargs_none.verbose isa OptimizationVerbosity
    end

    # Test user-specified optimize_kwargs verbose takes precedence
    @testset "User optimize_kwargs verbose precedence" begin
        user_verbose = OptimizationVerbosity(SciMLLogging.Minimal())
        bvp_verbose = BVPVerbosity(SciMLLogging.All())
        mock_opt_alg = :some_optimizer

        kwargs = __concrete_kwargs(
            nothing, mock_opt_alg,
            (;), (; verbose = user_verbose),
            bvp_verbose
        )

        @test kwargs.verbose === user_verbose
    end
end

@testitem "Solve problems with various verbosity settings" begin
    using BoundaryValueDiffEq, BoundaryValueDiffEqCore
    using BoundaryValueDiffEqCore: SciMLLogging
    using NonlinearSolveFirstOrder: NewtonRaphson

    # Simple BVP problem
    tspan = (0.0, 1.0)
    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
    end
    function bc!(res, u, p, t)
        res[1] = u[1][1]
        res[2] = u[end][1] - 1
    end
    u0 = [0.0, 1.0]
    prob = BVProblem(f!, bc!, u0, tspan)

    # Test all presets with MIRK
    @testset "MIRK with all verbosity presets" begin
        for preset in [
                SciMLLogging.None(), SciMLLogging.Minimal(),
                SciMLLogging.Standard(), SciMLLogging.Detailed(),
                SciMLLogging.All(),
            ]
            sol = solve(prob, MIRK4(), dt = 0.1, verbose = BVPVerbosity(preset))
            @test SciMLBase.successful_retcode(sol)
        end
    end

    # Test with explicit nonlinear solver
    @testset "MIRK with explicit nlsolve and various verbosity" begin
        for preset in [SciMLLogging.None(), SciMLLogging.All()]
            sol = solve(
                prob, MIRK4(nlsolve = NewtonRaphson()), dt = 0.1,
                verbose = BVPVerbosity(preset)
            )
            @test SciMLBase.successful_retcode(sol)
        end
    end

    # Test FIRK with various verbosity
    @testset "FIRK with various verbosity" begin
        for preset in [SciMLLogging.None(), SciMLLogging.Standard(), SciMLLogging.All()]
            sol = solve(prob, RadauIIa5(), dt = 0.1, verbose = BVPVerbosity(preset))
            @test SciMLBase.successful_retcode(sol)

            sol = solve(prob, LobattoIIIa4(), dt = 0.1, verbose = BVPVerbosity(preset))
            @test SciMLBase.successful_retcode(sol)
        end
    end

    # Test MIRKN with various verbosity
    @testset "MIRKN with various verbosity" begin
        function f2!(ddu, du, u, p, t)
            ddu[1] = -u[1]
        end
        function bc2!(res, du, u, p, t)
            res[1] = u[1][1]
            res[2] = u[end][1] - 1
        end
        u0_2 = [0.0]
        prob2 = SecondOrderBVProblem(f2!, bc2!, u0_2, tspan)

        for preset in [
                SciMLLogging.None(), SciMLLogging.Minimal(),
                SciMLLogging.Standard(), SciMLLogging.All(),
            ]
            sol = solve(prob2, MIRKN4(), dt = 0.1, verbose = BVPVerbosity(preset))
            @test SciMLBase.successful_retcode(sol)
        end
    end

    # Test with Boolean verbose (backward compatibility)
    @testset "Boolean verbose backward compatibility" begin
        sol_true = solve(prob, MIRK4(), dt = 0.1, verbose = true)
        @test SciMLBase.successful_retcode(sol_true)

        sol_false = solve(prob, MIRK4(), dt = 0.1, verbose = false)
        @test SciMLBase.successful_retcode(sol_false)
    end
end

# Put in a separate page so it can be used by SciMLDocs.jl

pages = [
    "index.md",
    "Getting Started with BVP solving in Julia" => "tutorials/getting_started.md",
    "Tutorials" => Any[
        "tutorials/continuation.md", "tutorials/solve_nlls_bvp.md",
        "tutorials/unknown_parameters.md", "tutorials/optimal_control.md", "tutorials/extremum.md",
    ],
    "Basics" => Any[
        "basics/bvp_problem.md", "basics/bvp_functions.md",
        "basics/solve.md", "basics/autodiff.md", "basics/error_control.md",
        "basics/verbosity.md",
    ],
    "Solver Summaries and Recommendations" => Any[
        "solvers/mirk.md", "solvers/firk.md", "solvers/shooting.md", "solvers/mirkn.md",
        "solvers/ascher.md", "solvers/simple_solvers.md", "solvers/wrappers.md",
    ],
    "Wrapped Solver APIs" => Any["api/odeinterface.md"],
    "Development Documentation" => Any["devdocs/internal_interfaces.md"],
    "References" => "references.md",
]

@testitem "Type Stability" begin
    using LinearAlgebra, BoundaryValueDiffEq, OrdinaryDiffEqTsit5, SciMLBase

    f(u, p, t) = [p[1] * u[1] - p[2] * u[1] * u[2], p[3] * u[1] * u[2] - p[4] * u[2]]
    function f!(du, u, p, t)
        du[1] = p[1] * u[1] - p[2] * u[1] * u[2]
        du[2] = p[3] * u[1] * u[2] - p[4] * u[2]
    end

    bc(sol, p, t) = [sol(0.0)[1] - 1, sol(1.0)[2] - 2]
    function bc!(res, sol, p, t)
        res[1] = sol(0.0)[1] - 1
        res[2] = sol(1.0)[2] - 2
    end
    twobc_a(ua, p) = [ua[1] - 1]
    twobc_b(ub, p) = [ub[2] - 2]
    twobc_a!(resa, ua, p) = (resa[1] = ua[1] - 1)
    twobc_b!(resb, ub, p) = (resb[1] = ub[2] - 2)

    u0 = Float64[0, 0]
    tspan = (0.0, 1.0)
    p = [1.0, 1.0, 1.0, 1.0]
    bcresid_prototype = (zeros(1), zeros(1))

    jac_alg = BVPJacobianAlgorithm(AutoForwardDiff(; chunksize = 2))

    # BVProblem constructor type stability (issue #454)
    # Explicit {iip} constructors should be type-stable
    @testset "BVProblem Constructor" begin
        @inferred BVProblem{true}(f!, bc!, u0, tspan, p)
        @inferred BVProblem{false}(f, bc, u0, tspan, p)

        # __init should be type-stable with properly typed problems
        prob_iip = BVProblem{true}(f!, bc!, u0, tspan, p)
        @inferred SciMLBase.__init(prob_iip, MIRK5(; jac_alg); dt = 0.2)
    end

    # Multi-Point BVP
    # nlls is properly inferred as false for StandardBVProblem without bcresid_prototype
    @testset "Multi-Point BVP" begin
        mpbvp_iip = BVProblem(f!, bc!, u0, tspan, p)
        mpbvp_oop = BVProblem(f, bc, u0, tspan, p)

        # Shooting methods have deep type instability from NonlinearSolve/OrdinaryDiffEq
        # that requires further investigation. The solvers work correctly but return type
        # inference fails due to complex generic types.
        # @testset "Shooting Methods" begin
        #     @inferred solve(mpbvp_iip, Shooting(Tsit5(); jac_alg))
        #     @inferred solve(mpbvp_oop, Shooting(Tsit5(); jac_alg))
        #     @inferred solve(mpbvp_iip, MultipleShooting(5, Tsit5(); jac_alg))
        #     @inferred solve(mpbvp_oop, MultipleShooting(5, Tsit5(); jac_alg))
        # end

        @testset "MIRK Methods" begin
            for solver in (
                    MIRK2(; jac_alg), MIRK3(; jac_alg), MIRK4(; jac_alg),
                    MIRK5(; jac_alg), MIRK6(; jac_alg),
                )
                @inferred solve(mpbvp_iip, solver; dt = 0.2)
                @inferred solve(mpbvp_oop, solver; dt = 0.2)
            end
        end
    end

    # Two-Point BVP
    @testset "Two-Point BVP" begin
        tpbvp_iip = TwoPointBVProblem(
            f!, (twobc_a!, twobc_b!), u0, tspan, p; bcresid_prototype, nlls = Val(false)
        )
        tpbvp_oop = TwoPointBVProblem(
            f, (twobc_a, twobc_b), u0, tspan, p; nlls = Val(false)
        )

        # Shooting methods have deep type instability - see comment above
        # @testset "Shooting Methods" begin
        #     @inferred solve(tpbvp_iip, Shooting(Tsit5(); jac_alg))
        #     @inferred solve(tpbvp_oop, Shooting(Tsit5(); jac_alg))
        #     @inferred solve(tpbvp_iip, MultipleShooting(5, Tsit5(); jac_alg))
        #     @inferred solve(tpbvp_oop, MultipleShooting(5, Tsit5(); jac_alg))
        # end

        @testset "MIRK Methods" begin
            for solver in (
                    MIRK2(; jac_alg), MIRK3(; jac_alg), MIRK4(; jac_alg),
                    MIRK5(; jac_alg), MIRK6(; jac_alg),
                )
                @inferred solve(tpbvp_iip, solver; dt = 0.2)
                @inferred solve(tpbvp_oop, solver; dt = 0.2)
            end
        end
    end
end

@testitem "BigFloat compatibility" begin
    using BoundaryValueDiffEq
    # Need Sparspak for BigFloat
    using Sparspak

    tspan = (0.0, pi / 2)
    function simplependulum!(du, u, p, t)
        θ = u[1]
        dθ = u[2]
        du[1] = dθ
        du[2] = -9.81 * sin(θ)
    end
    function bc!(residual, u, p, t)
        residual[1] = u(pi / 4)[1] + big(pi / 2)
        residual[2] = u(pi / 2)[1] - big(pi / 2)
    end
    u0 = BigFloat.([pi / 2, pi / 2])
    multi_point_bvp = BVProblem(simplependulum!, bc!, u0, tspan)

    @testset "BigFloat compatibility with Multi-point BVP" begin
        for solver in [MIRK4(), RadauIIa5(), LobattoIIIa4(nested_nlsolve = true)]
            sol = solve(multi_point_bvp, solver, dt = 0.05)
            @test SciMLBase.successful_retcode(sol.retcode)
        end
    end

    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = u[1]
    end
    function bca!(resid_a, u_a, p)
        resid_a[1] = u_a[1] - 1
    end
    function bcb!(resid_b, u_b, p)
        resid_b[1] = u_b[1]
    end
    bvp_function = BVPFunction(f!, (bca!, bcb!), bcresid_prototype = (zeros(1), zeros(1)), twopoint = Val(true))
    tspan = (0.0, 1.0)
    two_point_bvp = BVProblem(bvp_function, BigFloat.([1.0, 0.0]), tspan)

    @testset "BigFloat compatibility with Two-point BVP" begin
        for solver in [MIRK4(), RadauIIa5(), LobattoIIIa4(nested_nlsolve = true)]
            sol = solve(two_point_bvp, solver, dt = 0.05)
            @test SciMLBase.successful_retcode(sol.retcode)
        end
    end

    function second_f!(ddu, du, u, p, t)
        ϵ = 0.1
        ddu[1] = u[2]
        ddu[2] = (-u[1] * du[2] - u[3] * du[3]) / ϵ
        ddu[3] = (du[1] * u[3] - u[1] * du[3]) / ϵ
    end
    function second_bc!(res, du, u, p, t)
        res[1] = u(0.0)[1]
        res[2] = u(1.0)[1]
        res[3] = u(0.0)[3] + 1
        res[4] = u(1.0)[3] - 1
        res[5] = du(0.0)[1]
        res[6] = du(1.0)[1]
    end
    u0 = BigFloat.([1.0, 1.0, 1.0])
    tspan = (0.0, 1.0)
    prob = SecondOrderBVProblem(second_f!, second_bc!, u0, tspan)
    @test_broken sol4 = solve(prob, MIRKN4(), dt = 0.01)
    @test_broken SciMLBase.successful_retcode(sol4.retcode)
end

@testitem "Non-Vector Inputs" begin
    using LinearAlgebra, NonlinearSolveFirstOrder, OrdinaryDiffEqTsit5

    for order in (2, 3, 4, 5, 6)
        s = Symbol("MIRK$(order)")
        @eval mirk_solver(::Val{$order}) = $(s)()
    end

    function f1!(du, u, p, t)
        du[1, 1] = u[1, 2]
        du[1, 2] = 0
    end

    function f1(u, p, t)
        return [u[1, 2] 0]
    end

    function boundary!(residual, u, p, t)
        residual[1, 1] = u(0.0)[1, 1] - 5
        residual[1, 2] = u(5.0)[1, 1]
    end

    function boundary_a!(resida, ua, p)
        resida[1, 1] = ua[1, 1] - 5
    end
    function boundary_b!(residb, ub, p)
        residb[1, 1] = ub[1, 1]
    end

    function boundary(u, p, t)
        return [u(0.0)[1, 1] - 5 u(5.0)[1, 1]]
    end

    boundary_a = (ua, p) -> [ua[1, 1] - 5]
    boundary_b = (ub, p) -> [ub[1, 1]]

    tspan = (0.0, 5.0)
    u0 = [5.0 -3.5]
    probs = [
        BVProblem(f1!, boundary!, u0, tspan; nlls = Val(false)),
        TwoPointBVProblem(
            f1!, (boundary_a!, boundary_b!), u0, tspan;
            bcresid_prototype = (Array{Float64}(undef, 1, 1), Array{Float64}(undef, 1, 1)),
            nlls = Val(false)
        ),
        BVProblem(f1, boundary, u0, tspan; nlls = Val(false)),
        TwoPointBVProblem(f1, (boundary_a, boundary_b), u0, tspan; nlls = Val(false)),
    ]

    @testset "Affineness" begin
        @testset "MIRK$order" for order in (2, 3, 4, 5, 6)
            for prob in probs
                sol = solve(prob, mirk_solver(Val(order)); dt = 0.2)
                @test norm(boundary(sol, prob.p, nothing), Inf) < 0.01
            end
        end

        @testset "Single Shooting" begin
            for prob in probs
                sol = solve(prob, Shooting(Tsit5(), NewtonRaphson()))
                @test norm(boundary(sol, prob.p, nothing), Inf) < 0.01
            end
        end

        # FIXME: Add Multiple Shooting here once it supports non-vector inputs
        @testset "Multiple Shooting" begin
            for prob in probs
                @test_broken begin
                    sol = solve(prob, MultipleShooting(5, Tsit5()))
                    norm(boundary(sol, prob.p, nothing), Inf) < 0.01
                end
            end
        end
    end
end

module BoundaryValueDiffEqODEInterfaceExt

using BoundaryValueDiffEq: BVPM2, BVPSOL, COLNEW
using BoundaryValueDiffEqCore: __extract_u0, __initial_guess_length, __extract_mesh,
    __flatten_initial_guess, __get_bcresid_prototype,
    __has_initial_guess, __initial_guess, _process_verbose_param, BVPVerbosity, @SciMLMessage
using SciMLBase: SciMLBase, BVProblem, TwoPointBVProblem, ReturnCode
using ODEInterface: OptionsODE, OPT_ATOL, OPT_RTOL, OPT_METHODCHOICE, OPT_DIAGNOSTICOUTPUT,
    OPT_ERRORCONTROL, OPT_SINGULARTERM, OPT_MAXSTEPS, OPT_BVPCLASS,
    OPT_SOLMETHOD, OPT_RHS_CALLMODE, OPT_COLLOCATIONPTS, OPT_ADDGRIDPOINTS,
    OPT_MAXSUBINTERVALS, RHS_CALL_INSITU, evalSolution
using ODEInterface: Bvpm2, bvpm2_init, bvpm2_solve, bvpm2_destroy, bvpm2_get_x
using ODEInterface: bvpsol
using ODEInterface: colnew

using FastClosures: @closure
using ForwardDiff: ForwardDiff

#------
# BVPM2
#------
function SciMLBase.__solve(prob::BVProblem, alg::BVPM2; dt = 0.0, reltol = 1.0e-3, kwargs...)
    if !(prob.problem_type isa TwoPointBVProblem)
        throw(ArgumentError("`BVPM2` only supports `TwoPointBVProblem!`"))
    end

    t₀, t₁ = prob.tspan
    u0_ = __extract_u0(prob.u0, prob.p, t₀)
    u0_size = size(u0_)
    n = __initial_guess_length(prob.u0)

    n == -1 && dt ≤ 0 && throw(ArgumentError("`dt` must be positive."))

    mesh = __extract_mesh(prob.u0, t₀, t₁, ifelse(n == -1, dt, n - 1))
    n = length(mesh) - 1
    no_odes = length(u0_)

    if prob.f.bcresid_prototype !== nothing
        left_bc, right_bc = prob.f.bcresid_prototype.x
        left_bc_size, right_bc_size = size(left_bc), size(right_bc)
        no_left_bc = length(left_bc)
    else
        left_bc = prob.f.bc[1](u0_, prob.p) # Guaranteed to be out of place here
        no_left_bc = length(left_bc)
    end

    obj = Bvpm2()
    if prob.u0 isa Function
        guess_function = @closure (x, y) -> (y .= vec(__initial_guess(prob.u0, prob.p, x)))
        bvpm2_init(
            obj, no_odes, no_left_bc, mesh, guess_function,
            eltype(u0_)[], alg.max_num_subintervals
        )
    else
        u0 = __flatten_initial_guess(prob.u0)
        bvpm2_init(
            obj, no_odes, no_left_bc, mesh, u0, eltype(u0)[], alg.max_num_subintervals
        )
    end

    bvp2m_f = if SciMLBase.isinplace(prob)
        @closure (t, u, du) -> prob.f(reshape(du, u0_size), reshape(u, u0_size), prob.p, t)
    else
        @closure (t, u, du) -> du .= vec(prob.f(reshape(u, u0_size), prob.p, t))
    end
    bvp2m_bc = if SciMLBase.isinplace(prob)
        @closure (
            ya,
            yb,
            bca,
            bcb,
        ) -> begin
            prob.f.bc[1](reshape(bca, left_bc_size), reshape(ya, u0_size), prob.p)
            prob.f.bc[2](reshape(bcb, right_bc_size), reshape(yb, u0_size), prob.p)
            return nothing
        end
    else
        @closure (
            ya, yb, bca, bcb,
        ) -> begin
            bca .= vec(prob.f.bc[1](reshape(ya, u0_size), prob.p))
            bcb .= vec(prob.f.bc[2](reshape(yb, u0_size), prob.p))
            return nothing
        end
    end

    opt = OptionsODE(
        OPT_RTOL => reltol, OPT_METHODCHOICE => alg.method_choice,
        OPT_DIAGNOSTICOUTPUT => alg.diagnostic_output,
        OPT_SINGULARTERM => alg.singular_term, OPT_ERRORCONTROL => alg.error_control
    )

    sol, retcode, stats = bvpm2_solve(obj, bvp2m_f, bvp2m_bc, opt)
    retcode = retcode ≥ 0 ? ReturnCode.Success : ReturnCode.Failure
    destats = SciMLBase.DEStats(
        stats["no_rhs_calls"], 0, 0, 0, stats["no_jac_calls"], 0, 0, 0, 0, 0, 0, 0, 0
    )

    x_mesh = bvpm2_get_x(sol)
    evalsol = evalSolution(sol, x_mesh)
    ivpsol = SciMLBase.build_solution(
        prob, alg, x_mesh,
        map(x -> reshape(convert(Vector{eltype(evalsol)}, x), u0_size), eachcol(evalsol));
        retcode, stats = destats, original = (sol, retcode, stats)
    )

    bvpm2_destroy(obj)
    bvpm2_destroy(sol)

    return ivpsol
end

#-------
# BVPSOL
#-------
function SciMLBase.__solve(
        prob::BVProblem, alg::BVPSOL; maxiters = 1000,
        reltol = 1.0e-3, dt = 0.0, verbose = true, kwargs...
    )
    if !(prob.problem_type isa TwoPointBVProblem)
        throw(ArgumentError("`BVPSOL` only supports `TwoPointBVProblem!`"))
    end
    if !__has_initial_guess(prob.u0)
        throw(ArgumentError("Initial Guess is required for `BVPSOL`"))
    end

    verbose_spec = _process_verbose_param(verbose)

    t₀, t₁ = prob.tspan
    u0_ = __extract_u0(prob.u0, prob.p, t₀)
    u0_size = size(u0_)
    n = __initial_guess_length(prob.u0)

    n == -1 && dt ≤ 0 && throw(ArgumentError("`dt` must be positive."))
    u0 = __flatten_initial_guess(prob.u0)
    mesh = __extract_mesh(prob.u0, t₀, t₁, ifelse(n == -1, dt, n - 1))
    if u0 === nothing
        # initial_guess function was provided
        u0 = mapreduce(@closure(t -> vec(__initial_guess(prob.u0, prob.p, t))), hcat, mesh)
    end

    if prob.f.bcresid_prototype !== nothing
        left_bc, right_bc = prob.f.bcresid_prototype.x
        left_bc_size, right_bc_size = size(left_bc), size(right_bc)
        no_left_bc = length(left_bc)
    else
        left_bc = prob.f.bc[1](u0_, prob.p) # Guaranteed to be out of place here
        no_left_bc = length(left_bc)
    end

    opt = OptionsODE(
        OPT_RTOL => reltol, OPT_MAXSTEPS => maxiters, OPT_BVPCLASS => alg.bvpclass,
        OPT_SOLMETHOD => alg.sol_method, OPT_RHS_CALLMODE => RHS_CALL_INSITU
    )

    bvpsol_f = if SciMLBase.isinplace(prob)
        @closure (t, u, du) -> prob.f(reshape(du, u0_size), reshape(u, u0_size), prob.p, t)
    else
        @closure (t, u, du) -> du .= vec(prob.f(reshape(u, u0_size), prob.p, t))
    end

    bvpsol_bc = if SciMLBase.isinplace(prob)
        @closure (
            ya, yb,
            r,
        ) -> begin
            left_bc = reshape(@view(r[1:no_left_bc]), left_bc_size)
            right_bc = reshape(@view(r[(no_left_bc + 1):end]), right_bc_size)
            prob.f.bc[1](left_bc, reshape(ya, u0_size), prob.p)
            prob.f.bc[2](right_bc, reshape(yb, u0_size), prob.p)
            return nothing
        end
    else
        @closure (
            ya,
            yb,
            r,
        ) -> begin
            r[1:no_left_bc] .= vec(prob.f.bc[1](reshape(ya, u0_size), prob.p))
            r[(no_left_bc + 1):end] .= vec(prob.f.bc[2](reshape(yb, u0_size), prob.p))
            return nothing
        end
    end

    sol_t, sol_x, retcode, stats = bvpsol(bvpsol_f, bvpsol_bc, mesh, u0, alg.odesolver, opt)

    if retcode == -3
        @SciMLMessage(
            "BVPSOL: Integrator failed to complete the trajectory (retcode=-3)",
            verbose_spec,
            :bvpsol_integrator
        )
    elseif retcode == -4
        @SciMLMessage(
            "BVPSOL: Gauss Newton method failed to converge (retcode=-4)",
            verbose_spec,
            :bvpsol_convergence
        )
    elseif retcode == -5
        @SciMLMessage(
            "BVPSOL: Given initial values inconsistent with separable linear bc (retcode=-5)",
            verbose_spec,
            :bvpsol_bc_inconsistent
        )
    elseif retcode == -6
        @SciMLMessage(
            "BVPSOL: Iterative refinement failed to converge for `sol_method=0`. Termination since multiple shooting condition or condition of Jacobian is too bad for `sol_method=1` (retcode=-6)",
            verbose_spec,
            :bvpsol_convergence
        )
    elseif retcode == -8
        @SciMLMessage(
            "BVPSOL: Condensing algorithm for linear block system fails, try `sol_method=1` (retcode=-8)",
            verbose_spec,
            :bvpsol_linear_solver
        )
    elseif retcode == -9
        @SciMLMessage(
            "BVPSOL: Sparse linear solver failed (retcode=-9)",
            verbose_spec,
            :bvpsol_linear_solver
        )
    elseif retcode == -10
        @SciMLMessage(
            "BVPSOL: Real or integer work-space exhausted (retcode=-10)",
            verbose_spec,
            :bvpsol_resources
        )
    elseif retcode == -11
        @SciMLMessage(
            "BVPSOL: Rank reduction failed - resulting rank is zero (retcode=-11)",
            verbose_spec,
            :bvpsol_linear_solver
        )
    end

    # Determine the return code for SciMLBase
    # For retcode -5 (initial values inconsistent with separable linear bc),
    # the solver may still produce a valid solution. Check the BC residuals
    # to determine if the solution is acceptable.
    sciml_retcode = if retcode ≥ 0
        ReturnCode.Success
    elseif retcode == -5
        # Check if the solution satisfies the boundary conditions within tolerance
        ya = sol_x[:, 1]
        yb = sol_x[:, end]
        bc_resid = zeros(eltype(sol_x), length(ya))
        bvpsol_bc(ya, yb, bc_resid)
        # Use the same tolerance as the solver
        if maximum(abs, bc_resid) ≤ reltol
            ReturnCode.Success
        else
            ReturnCode.Failure
        end
    else
        ReturnCode.Failure
    end

    ivpsol = SciMLBase.build_solution(
        prob, alg, sol_t,
        map(x -> reshape(convert(Vector{eltype(u0_)}, x), u0_size), eachcol(sol_x));
        retcode = sciml_retcode, stats, original = (sol_t, sol_x, retcode, stats)
    )

    return ivpsol
end

#-------
# COLNEW
#-------
function SciMLBase.__solve(
        prob::BVProblem, alg::COLNEW; maxiters = 1000,
        reltol = 1.0e-3, dt = 0.0, verbose = true, kwargs...
    )
    dt ≤ 0 && throw(ArgumentError("`dt` must be positive"))

    verbose_spec = _process_verbose_param(verbose)

    t₀, t₁ = prob.tspan
    u0_ = __extract_u0(prob.u0, prob.p, t₀)
    u0_size = size(u0_)
    n = __initial_guess_length(prob.u0)

    u0 = __flatten_initial_guess(prob.u0)
    mesh = __extract_mesh(prob.u0, t₀, t₁, ifelse(n == -1, dt, n - 1))
    if u0 === nothing
        # initial_guess function was provided
        u0 = mapreduce(@closure(t -> vec(__initial_guess(prob.u0, prob.p, t))), hcat, mesh)
    end

    no_odes = length(u0_)

    # has_initial_guess = prob.u0 isa AbstractVector{<:AbstractArray}
    # dt ≤ 0 && throw(ArgumentError("dt must be positive"))
    # no_odes, n, u0 = if has_initial_guess
    #     length(first(prob.u0)), (length(prob.u0) - 1), reduce(hcat, prob.u0)
    # else
    #     length(prob.u0), Int(cld((prob.tspan[2] - prob.tspan[1]), dt)), prob.u0
    # end

    T = eltype(u0)
    # mesh = collect(range(prob.tspan[1], stop = prob.tspan[2], length = n + 1))
    orders = ones(Int, no_odes)
    _tspan = [prob.tspan[1], prob.tspan[2]]
    iip = SciMLBase.isinplace(prob)

    rhs = @closure (t, u, du) -> begin
        if iip
            prob.f(du, u, prob.p, t)
        else
            (du .= prob.f(u, prob.p, t))
        end
    end

    if prob.f.jac === nothing
        if iip
            jac = (df, u, p, t) -> begin
                _du = similar(u)
                prob.f(_du, u, p, t)
                _f = @closure (du, u) -> prob.f(du, u, p, t)
                ForwardDiff.jacobian!(df, _f, _du, u)
                return
            end
        else
            jac = (df, u, p, t) -> begin
                _du = prob.f(u, p, t)
                _f = @closure (du, u) -> (du .= prob.f(u, p, t))
                ForwardDiff.jacobian!(df, _f, _du, u)
                return
            end
        end
    else
        jac = prob.f.jac
    end
    Drhs = @closure (t, u, df) -> jac(df, u, prob.p, t)

    bcresid_prototype, _ = __get_bcresid_prototype(prob.problem_type, prob, u0)

    if prob.problem_type isa TwoPointBVProblem
        n_bc_a = length(first(bcresid_prototype))
        n_bc_b = length(last(bcresid_prototype))
        zeta = vcat(fill(first(prob.tspan), n_bc_a), fill(last(prob.tspan), n_bc_b))
        bc = @closure (i, z, resid) -> begin
            tmpa = copy(z)
            tmpb = copy(z)
            tmp_resid_a = zeros(T, n_bc_a)
            tmp_resid_b = zeros(T, n_bc_b)
            prob.f.bc[1](tmp_resid_a, tmpa, prob.p)
            prob.f.bc[2](tmp_resid_b, tmpb, prob.p)

            for j in 1:n_bc_a
                if i == j
                    resid[1] = tmp_resid_a[j]
                end
            end
            for j in 1:n_bc_b
                if i == (j + n_bc_a)
                    resid[1] = tmp_resid_b[j]
                end
            end
        end

        Dbc = @closure (i, z, dbc) -> begin
            for j in 1:n_bc_a
                if i == j
                    dbc[i] = 1.0
                end
            end
            for j in 1:n_bc_b
                if i == (j + n_bc_a)
                    dbc[i] = 1.0
                end
            end
        end
        fixed_points = nothing
    else
        zeta = sort(alg.zeta)
        bc = alg.bc_func
        Dbc = alg.dbc_func
        left_index = findlast(x -> x ≈ t₀, zeta) + 1
        right_index = findfirst(x -> x ≈ t₁, zeta) - 1
        fixed_points = alg.zeta[left_index:right_index]
    end

    if fixed_points === nothing
        opt = OptionsODE(
            OPT_BVPCLASS => alg.bvpclass, OPT_COLLOCATIONPTS => alg.collocationpts,
            OPT_MAXSTEPS => maxiters, OPT_DIAGNOSTICOUTPUT => alg.diagnostic_output,
            OPT_MAXSUBINTERVALS => alg.max_num_subintervals, OPT_RTOL => reltol
        )
    else
        opt = OptionsODE(
            OPT_BVPCLASS => alg.bvpclass, OPT_COLLOCATIONPTS => alg.collocationpts,
            OPT_MAXSTEPS => maxiters, OPT_DIAGNOSTICOUTPUT => alg.diagnostic_output,
            OPT_MAXSUBINTERVALS => alg.max_num_subintervals,
            OPT_RTOL => reltol, OPT_ADDGRIDPOINTS => fixed_points
        )
    end

    sol, retcode, stats = colnew(_tspan, orders, zeta, rhs, Drhs, bc, Dbc, nothing, opt)

    if retcode == 0
        @SciMLMessage(
            "COLNEW: Collocation matrix is singular (retcode=0)",
            verbose_spec,
            :colnew_matrix
        )
    elseif retcode == -1
        @SciMLMessage(
            "COLNEW: The expected no. of subintervals exceeds storage (try to increase `OPT_MAXSUBINTERVALS`) (retcode=-1)",
            verbose_spec,
            :colnew_resources
        )
    elseif retcode == -2
        @SciMLMessage(
            "COLNEW: The nonlinear iteration has not converged (retcode=-2)",
            verbose_spec,
            :colnew_convergence
        )
    elseif retcode == -3
        @SciMLMessage(
            "COLNEW: There is an input data error (retcode=-3)",
            verbose_spec,
            :colnew_input
        )
    end

    evalsol = evalSolution(sol, mesh)
    destats = SciMLBase.DEStats(
        stats["no_rhs_calls"], 0, 0, 0, stats["no_jac_calls"], 0, 0, 0, 0, 0, 0, 0, 0
    )

    return SciMLBase.build_solution(
        prob, alg, mesh, collect(Vector{eltype(evalsol)}, eachrow(evalsol));
        retcode = retcode > 0 ? ReturnCode.Success : ReturnCode.Failure,
        stats = destats, original = (sol, retcode, stats)
    )
end

export BVPM2, BVPSOL, COLNEW

end

@testitem "Scalar BVP tests" begin
    using BoundaryValueDiffEq, LinearAlgebra, OrdinaryDiffEqTsit5, SciMLBase
    tspan = (0.0, 2.0)

    f(u, p, t) = t * u
    bca(ua, p) = ua - 1
    bcb(ub, p) = ub - exp(2)

    u₀ = 1.0

    bvproblem = TwoPointBVProblem(f, (bca, bcb), u₀, tspan)
    sol = solve(bvproblem, MIRK4(); dt = 0.01)
    @test SciMLBase.successful_retcode(sol)
    @test norm(sol.resid, Inf) < 1.0e-6

    shoot_sol = solve(
        bvproblem, Shooting(Tsit5()); abstol = 1.0e-8, reltol = 1.0e-8,
        odesolve_kwargs = (; abstol = 1.0e-9, reltol = 1.0e-9)
    )
    @test SciMLBase.successful_retcode(shoot_sol)
    @test norm(shoot_sol.resid, Inf) < 1.0e-6
end

module SimplePendulumBenchmark

    using BoundaryValueDiffEq, OrdinaryDiffEq, NonlinearSolveFirstOrder

    const tspan = (0.0, π / 2)

    function simple_pendulum!(du, u, p, t)
        g, L, θ, dθ = 9.81, 1.0, u[1], u[2]
        du[1] = dθ
        du[2] = -(g / L) * sin(θ)
        return nothing
    end

    function bc_pendulum!(residual, u, p, t)
        t0, t1 = tspan
        residual[1] = u((t0 + t1) / 2)[1] + π / 2
        residual[2] = u(t1)[1] - π / 2
        return nothing
    end

    function simple_pendulum(u, p, t)
        g, L, θ, dθ = 9.81, 1.0, u[1], u[2]
        return [dθ, -(g / L) * sin(θ)]
    end

    function bc_pendulum(u, p, t)
        t0, t1 = tspan
        return [u((t0 + t1) / 2)[1] + π / 2, u(t1)[1] - π / 2]
    end

    const prob_oop = BVProblem{false}(simple_pendulum, bc_pendulum, [π / 2, π / 2], tspan)
    const prob_iip = BVProblem{true}(simple_pendulum!, bc_pendulum!, [π / 2, π / 2], tspan)

end

function create_simple_pendulum_benchmark()
    suite = BenchmarkGroup()

    iip_suite = BenchmarkGroup()
    oop_suite = BenchmarkGroup()

    suite["IIP"] = iip_suite
    suite["OOP"] = oop_suite

    if @isdefined(MultipleShooting)
        iip_suite["MultipleShooting(100, Tsit5; grid_coarsening = true)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_iip, $MultipleShooting(100, Tsit5(), NewtonRaphson())
        )
        iip_suite["MultipleShooting(100, Tsit5; grid_coarsening = false)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_iip,
            $MultipleShooting(100, Tsit5(), NewtonRaphson(); grid_coarsening = false)
        )
        iip_suite["MultipleShooting(10, Tsit5; grid_coarsening = true)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_iip, $MultipleShooting(10, Tsit5(), NewtonRaphson())
        )
        iip_suite["MultipleShooting(10, Tsit5; grid_coarsening = false)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_iip,
            $MultipleShooting(10, Tsit5(), NewtonRaphson(); grid_coarsening = false)
        )
    end
    if @isdefined(Shooting)
        iip_suite["Shooting(Tsit5())"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_iip, $Shooting(Tsit5(), NewtonRaphson())
        )
    end
    for alg in (MIRK2, MIRK3, MIRK4, MIRK5, MIRK6)
        if @isdefined(alg)
            iip_suite["$alg()"] = @benchmarkable solve($SimplePendulumBenchmark.prob_iip, $alg(), dt = 0.05)
        end
    end

    if @isdefined(MultipleShooting)
        oop_suite["MultipleShooting(100, Tsit5; grid_coarsening = true)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_oop, $MultipleShooting(100, Tsit5(), NewtonRaphson())
        )
        oop_suite["MultipleShooting(100, Tsit5; grid_coarsening = false)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_oop,
            $MultipleShooting(100, Tsit5(), NewtonRaphson(); grid_coarsening = false)
        )
        oop_suite["MultipleShooting(10, Tsit5; grid_coarsening = true)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_oop, $MultipleShooting(10, Tsit5(), NewtonRaphson())
        )
        oop_suite["MultipleShooting(10, Tsit5; grid_coarsening = false)"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_oop,
            $MultipleShooting(10, Tsit5(), NewtonRaphson(); grid_coarsening = false)
        )
    end
    if @isdefined(Shooting)
        oop_suite["Shooting(Tsit5())"] = @benchmarkable solve(
            $SimplePendulumBenchmark.prob_oop, $Shooting(Tsit5(), NewtonRaphson())
        )
    end
    for alg in (MIRK2, MIRK3, MIRK4, MIRK5, MIRK6)
        if @isdefined(alg)
            oop_suite["$alg()"] = @benchmarkable solve($SimplePendulumBenchmark.prob_oop, $alg(), dt = 0.05)
        end
    end

    return suite
end

@testitem "Default Solvers" begin
    using BoundaryValueDiffEq, Test

    function f(du, u, p, t)
        (x, v) = u
        du[1] = v
        du[2] = -x
    end

    function bc!(resid, sol, p, t)
        resid[1] = sol.u[1][1]
        resid[2] = sol.u[end][1] - 1
    end

    tspan = (0.0, 100.0)
    u0 = [0.0, 1.0]
    bvp = BVProblem(f, bc!, u0, tspan)
    resid_f = Array{Float64}(undef, 2)
    sol = solve(bvp, Shooting(Tsit5()))
    sol2 = solve(bvp)

    @test sol2.alg == Tsit5()
    @test all(sol.u .== sol2.u)
end

# Algorithms from ODEInterface.jl
"""
    BVPM2(; max_num_subintervals = 3000, method_choice = 4, diagnostic_output = 1,
        error_control = 1, singular_term = nothing)
    BVPM2(max_num_subintervals::Int, method_choice::Int, diagnostic_output::Int,
        error_control::Int, singular_term)

Fortran code for solving two-point boundary value problems. For detailed documentation, see
[ODEInterface.jl](https://github.com/luchr/ODEInterface.jl/blob/master/doc/SolverOptions.md#bvpm2).

## Keyword Arguments:

- `max_num_subintervals`: Number of maximal subintervals, default as 3000.
- `method_choice`: Choice for IVP-solvers, default as Runge-Kutta method of order 4,
  available choices:
    - `2`: Runge-Kutta method of order 2.
    - `4`: Runge-Kutta method of order 4.
    - `6`: Runge-Kutta method of order 6.
- `diagnostic_output`: Diagnostic output for BVPM2, default as non printout, available
  choices:
    - `-1`: Full diagnostic printout.
    - `0`: Selected printout.
    - `1`: No printout.
- `error_control`: Determines the error-estimation for which RTOL is used, default as
  defect control, available choices:
    - `1`: Defect control.
    - `2`: Global error control.
    - `3`: Defect and then global error control.
    - `4`: Linear combination of defect and global error control.
- `singular_term`: either nothing if the ODEs have no singular terms at the left
  boundary or a constant (d,d) matrix for the singular term.

!!! note

    Only available if the `ODEInterface` package is loaded.
"""
struct BVPM2{S} <: AbstractBoundaryValueDiffEqAlgorithm
    max_num_subintervals::Int
    method_choice::Int
    diagnostic_output::Int
    error_control::Int
    singular_term::S

    function BVPM2(
            max_num_subintervals::Int, method_choice::Int, diagnostic_output::Int,
            error_control::Int, singular_term::Union{Nothing, AbstractMatrix}
        )
        if Base.get_extension(@__MODULE__, :BoundaryValueDiffEqODEInterfaceExt) === nothing
            error("`BVPM2` requires `ODEInterface.jl` to be loaded")
        end
        return new{typeof(singular_term)}(
            max_num_subintervals, method_choice,
            diagnostic_output, error_control, singular_term
        )
    end
end

function BVPM2(;
        max_num_subintervals::Int = 3000, method_choice::Int = 4,
        diagnostic_output::Int = -1, error_control::Int = 1, singular_term = nothing
    )
    return BVPM2(
        max_num_subintervals, method_choice,
        diagnostic_output, error_control, singular_term
    )
end

"""
    BVPSOL(; bvpclass = 2, sol_method = 0, odesolver = nothing)
    BVPSOL(bvpclass::Int, sol_methods::Int, odesolver)

A FORTRAN77 code which solves highly nonlinear **two point boundary value problems** using a
local linear solver (condensing algorithm) or a global sparse linear solver for the solution
of the arising linear subproblems, by Peter Deuflhard, Georg Bader, Lutz Weimann.
For detailed documentation, see
[ODEInterface.jl](https://github.com/luchr/ODEInterface.jl/blob/master/doc/SolverOptions.md#bvpsol).

## Keyword Arguments

- `bvpclass`: Boundary value problem classification, default as highly nonlinear with
  bad initial data, available choices:
    - `0`: Linear boundary value problem.
    - `1`: Nonlinear with good initial data.
    - `2`: Highly Nonlinear with bad initial data.
    - `3`: Highly nonlinear with bad initial data and initial rank reduction to
      separable linear boundary conditions.
- `sol_method`: Switch for solution methods, default as local linear solver with
  condensing algorithm, available choices:
    - `0`: Use local linear solver with condensing algorithm.
    - `1`: Use global sparse linear solver.
- `odesolver`: Either `nothing` or ode-solver(dopri5, dop853, seulex, etc.).

!!! note

    Only available if the `ODEInterface` package is loaded.
"""
struct BVPSOL{O} <: AbstractBoundaryValueDiffEqAlgorithm
    bvpclass::Int
    sol_method::Int
    odesolver::O

    function BVPSOL(bvpclass::Int, sol_method::Int, odesolver)
        if Base.get_extension(@__MODULE__, :BoundaryValueDiffEqODEInterfaceExt) === nothing
            error("`BVPSOL` requires `ODEInterface.jl` to be loaded")
        end
        return new{typeof(odesolver)}(bvpclass, sol_method, odesolver)
    end
end

function BVPSOL(; bvpclass = 2, sol_method = 0, odesolver = nothing)
    return BVPSOL(bvpclass, sol_method, odesolver)
end

"""
    COLNEW(; bvpclass = 1, collocationpts = 7, diagnostic_output = 1,
        max_num_subintervals = 3000, bc_func = nothing, dbc_func = nothing,
        zeta = nothing)
    COLNEW(bvpclass::Int, collocationpts::Int, diagnostic_output::Int,
        max_num_subintervals::Int, bc_func, dbc_func, zeta::AbstractVector)

## Keyword Arguments:

  - `bvpclass`: Boundary value problem classification, default as nonlinear and
    "extra sensitive", available choices:

      + `0`: Linear boundary value problem.
      + `1`: Nonlinear and regular.
      + `2`: Nonlinear and "extra sensitive" (first relax factor is rstart and the
        nonlinear iteration does not rely on past convergence).
      + `3`: fail-early: return immediately upon: a) two successive non-convergences.
        b) after obtaining an error estimate for the first time.

  - `collocationpts`: Number of collocation points per subinterval. Require
    orders[i] ≤ k ≤ 7, default as 7
  - `diagnostic_output`: Diagnostic output for COLNEW, default as no printout, available
    choices:

      + `-1`: Full diagnostic printout.
      + `0`: Selected printout.
      + `1`: No printout.
  - `max_num_subintervals`: Number of maximal subintervals, default as 3000.
  - `bc_func`: Boundary condition accord with ODEInterface.jl, only used for multi-points BVP.
  - `dbc_func`: Jacobian of boundary condition accord with ODEInterface.jl, only used for multi-points BVP.
  - `zeta`: The points in interval where boundary conditions are specified, only used for multi-points BVP.

A Fortran77 code solves a multi-points boundary value problems for a mixed order system of
ODEs. It incorporates a new basis representation replacing b-splines, and improvements for
the linear and nonlinear algebraic equation solvers.

!!! warning

    Only supports two-point boundary value problems.

!!! note

    Only available if the `ODEInterface` package is loaded.
"""
struct COLNEW <: AbstractBoundaryValueDiffEqAlgorithm
    bvpclass::Int
    collocationpts::Int
    diagnostic_output::Int
    max_num_subintervals::Int
    bc_func::Union{Function, Nothing}
    dbc_func::Union{Function, Nothing}
    zeta::Union{AbstractVector, Nothing}

    function COLNEW(
            bvpclass::Int, collocationpts::Int, diagnostic_output::Int,
            max_num_subintervals::Int, bc_func::Union{Function, Nothing},
            dbc_func::Union{Function, Nothing}, zeta::Union{AbstractVector, Nothing}
        )
        if Base.get_extension(@__MODULE__, :BoundaryValueDiffEqODEInterfaceExt) === nothing
            error("`COLNEW` requires `ODEInterface.jl` to be loaded")
        end
        return new(
            bvpclass, collocationpts, diagnostic_output,
            max_num_subintervals, bc_func, dbc_func, zeta
        )
    end
end

function COLNEW(;
        bvpclass::Int = 1, collocationpts::Int = 7, diagnostic_output::Int = 1,
        max_num_subintervals::Int = 3000, bc_func::Union{Function, Nothing} = nothing,
        dbc_func::Union{Function, Nothing} = nothing,
        zeta::Union{AbstractVector, Nothing} = nothing
    )
    return COLNEW(
        bvpclass, collocationpts, diagnostic_output,
        max_num_subintervals, bc_func, dbc_func, zeta
    )
end

using BoundaryValueDiffEq, Aqua, JET, Test, SciMLBase

@testset "Quality Assurance" begin
    @testset "Aqua" begin
        Aqua.test_all(
            BoundaryValueDiffEq; ambiguities = false,
            piracies = (broken = false, treat_as_own = [SciMLBase.BVProblem])
        )
    end

    @testset "JET" begin
        rep = JET.report_package(
            BoundaryValueDiffEq;
            target_modules = (BoundaryValueDiffEq,)
        )
        @test length(JET.get_reports(rep)) == 0
    end
end

@testitem "Manifolds.jl Integration" begin
    using LinearAlgebra, OrdinaryDiffEqTsit5

    struct EmbeddedTorus
        R::Float64
        r::Float64
    end

    function affine_connection!(M::EmbeddedTorus, Zc, i, a, Xc, Yc)
        θ = a[1] .+ i[1]
        sinθ, cosθ = sincos(θ)
        Γ¹₂₂ = (M.R + M.r * cosθ) * sinθ / M.r
        Γ²₁₂ = -M.r * sinθ / (M.R + M.r * cosθ)

        Zc[1] = Xc[2] * Γ¹₂₂ * Yc[2]
        Zc[2] = Γ²₁₂ * (Xc[1] * Yc[2] + Xc[2] * Yc[1])
        return Zc
    end

    M = EmbeddedTorus(3, 2)
    a1 = [0.5, -1.2]
    a2 = [-0.5, 0.3]
    i = (0, 0)
    solver = MIRK4()
    dt = 0.05
    tspan = (0.0, 1.0)

    function bc1!(residual, u, params, t)
        M, i, a1, a2 = params
        mid = div(length(u(0.0)), 2)
        residual[1:mid] = u(0.0)[1:mid] - a1
        residual[(mid + 1):end] = u(1.0)[1:mid] - a2
        return
    end

    function chart_log_problem!(du, u, params, t)
        M, i, a1, a2 = params
        mid = div(length(u), 2)
        a = u[1:mid]
        dx = u[(mid + 1):end]
        ddx = similar(dx)
        affine_connection!(M, ddx, i, a, dx, dx)
        ddx .*= -1
        du[1:mid] .= dx
        du[(mid + 1):end] .= ddx
        return du
    end

    @testset "Successful Convergence" begin
        u0 = [vcat(a1, zero(a1)), vcat(a2, zero(a1))]
        bvp1 = BVProblem(chart_log_problem!, bc1!, u0, tspan, (M, i, a1, a2))
        sol1 = solve(bvp1, solver, dt = dt)
        @test SciMLBase.successful_retcode(sol1.retcode)
    end

    function initial_guess_1(p, t)
        _, _, a1, a2 = p
        return vcat(t * a1 + (1 - t) * a2, zero(a1))
    end

    algs = [Shooting(Tsit5()), MultipleShooting(10, Tsit5()), MIRK4(), MIRK5(), MIRK6()]

    @testset "Initial Guess Functions" begin
        bvp = BVProblem(chart_log_problem!, bc1!, initial_guess_1, tspan, (M, i, a1, a2))

        for alg in algs
            if alg isa Shooting || alg isa MultipleShooting
                sol = solve(bvp, alg; abstol = 1.0e-8)
            else
                sol = solve(bvp, alg; dt, abstol = 1.0e-8)
            end
            @test SciMLBase.successful_retcode(sol)
            resid = zeros(4)
            bc1!(resid, sol, (M, i, a1, a2), sol.t)
            @test norm(resid, Inf) < 1.0e-10
        end
    end
end

using ReTestItems, BoundaryValueDiffEq, Hwloc, InteractiveUtils, Pkg

@info sprint(InteractiveUtils.versioninfo)

const GROUP = lowercase(get(ENV, "GROUP", "All"))

const RETESTITEMS_NWORKERS = parse(
    Int,
    get(
        ENV, "RETESTITEMS_NWORKERS",
        string(min(ifelse(Sys.iswindows(), 0, Hwloc.num_physical_cores()), 4))
    )
)
const RETESTITEMS_NWORKER_THREADS = parse(
    Int,
    get(
        ENV, "RETESTITEMS_NWORKER_THREADS",
        string(max(Hwloc.num_virtual_cores() ÷ max(RETESTITEMS_NWORKERS, 1), 1))
    )
)

@info "Running tests for group: $(GROUP) with $(RETESTITEMS_NWORKERS) workers"

if GROUP == "wrappers"
    # Wrapper tests must be explicitly requested via GROUP=wrappers
    ReTestItems.runtests(
        joinpath(@__DIR__, "wrappers");
        nworkers = RETESTITEMS_NWORKERS, nworker_threads = RETESTITEMS_NWORKER_THREADS
    )
else
    # For "all" and other groups, exclude wrappers (they have external deps like ODEInterface)
    for dir in readdir(@__DIR__)
        dirpath = joinpath(@__DIR__, dir)
        isdir(dirpath) || continue
        dir in ("wrappers", "qa") && continue
        ReTestItems.runtests(
            dirpath;
            tags = (GROUP == "all" ? nothing : [Symbol(GROUP)]),
            nworkers = RETESTITEMS_NWORKERS, nworker_threads = RETESTITEMS_NWORKER_THREADS
        )
    end
end

using Documenter, DocumenterCitations, DocumenterInterLinks
import DiffEqBase

using BoundaryValueDiffEqCore, BoundaryValueDiffEqMIRK, BoundaryValueDiffEqFIRK,
    BoundaryValueDiffEqMIRKN
using BoundaryValueDiffEqShooting
using BoundaryValueDiffEqAscher
using SciMLBase, DiffEqBase
using BoundaryValueDiffEq
using SimpleBoundaryValueDiffEq

cp(joinpath(@__DIR__, "Manifest.toml"), joinpath(@__DIR__, "src/assets/Manifest.toml"); force = true)
cp(joinpath(@__DIR__, "Project.toml"), joinpath(@__DIR__, "src/assets/Project.toml"); force = true)

include("pages.jl")

bib = CitationBibliography(joinpath(@__DIR__, "src", "refs.bib"))

interlinks = InterLinks(
    "ADTypes" => "https://sciml.github.io/ADTypes.jl/stable/",
    "LineSearch" => "https://sciml.github.io/LineSearch.jl/dev/"
)

makedocs(;
    sitename = "BoundaryValueDiffEq.jl",
    authors = "SciML",
    modules = [
        BoundaryValueDiffEqCore, BoundaryValueDiffEqMIRK, BoundaryValueDiffEqFIRK,
        BoundaryValueDiffEqMIRKN, BoundaryValueDiffEqShooting, BoundaryValueDiffEqAscher,
        SciMLBase, DiffEqBase, BoundaryValueDiffEq, SimpleBoundaryValueDiffEq,
    ],
    clean = true,
    doctest = false,
    checkdocs = :exports,
    warnonly = [:missing_docs, :cross_references],
    plugins = [bib, interlinks],
    format = Documenter.HTML(
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/BoundaryValueDiffEq/stable/"
    ),
    pages
)

deploydocs(repo = "github.com/SciML/BoundaryValueDiffEq.jl.git"; push_preview = true)

@testitem "Mesh redistribution in adaptivity" begin
    using BoundaryValueDiffEq

    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = -t / p * u[2] - pi^2 * cos(pi * t) - pi * t / p * sin(pi * t)
    end
    function bc!(res, u, p, t)
        res[1] = u[:, 1][1] + 2
        res[2] = u[:, end][1]
    end
    tspan = (-1.0, 1.0)
    sol = [1.0, 0.0]
    prob = BVProblem(f!, bc!, sol, tspan, 0.001)

    for order in (2, 3, 4, 5, 6)
        s = Symbol("MIRK$(order)")
        @eval mirk_solver(::Val{$order}) = $(s)()
    end
    for stage in (2, 3, 4, 5)
        s = Symbol("LobattoIIIa$(stage)")
        @eval lobattoIIIa_solver(::Val{$stage}, args...; kwargs...) = $(s)(args...; kwargs...)
    end

    for stage in (3, 4, 5)
        s = Symbol("LobattoIIIb$(stage)")
        @eval lobattoIIIb_solver(::Val{$stage}, args...; kwargs...) = $(s)(args...; kwargs...)
    end

    for stage in (3, 4, 5)
        s = Symbol("LobattoIIIc$(stage)")
        @eval lobattoIIIc_solver(::Val{$stage}, args...; kwargs...) = $(s)(args...; kwargs...)
    end

    for stage in (2, 3, 5, 7)
        s = Symbol("RadauIIa$(stage)")
        @eval radau_solver(::Val{$stage}, args...; kwargs...) = $(s)(args...; kwargs...)
    end
    @testset "MIRK$order method" for order in (2, 3, 4, 5, 6)
        @test_nowarn sol = solve(prob, mirk_solver(Val(order)), dt = 0.01)
    end

    @testset "RadauIIa$stage method" for stage in (2, 3, 5, 7)
        @test_nowarn sol = solve(prob, radau_solver(Val(stage)), dt = 0.01)
    end

    @testset "LobattoIIIa$stage method" for stage in (2, 3, 4, 5)
        @test_nowarn sol = solve(prob, lobattoIIIa_solver(Val(stage)), dt = 0.01)
    end

    @testset "LobattoIIIb$stage method" for stage in (3, 4, 5)
        @test_nowarn sol = solve(prob, lobattoIIIb_solver(Val(stage)), dt = 0.01)
    end

    @testset "LobattoIIIc$stage method" for stage in (3, 4, 5)
        @test_nowarn sol = solve(prob, lobattoIIIc_solver(Val(stage)), dt = 0.01)
    end
end

module BoundaryValueDiffEq

using ADTypes
using BoundaryValueDiffEqAscher
using BoundaryValueDiffEqCore: AbstractBoundaryValueDiffEqAlgorithm, BVPVerbosity,
    DEFAULT_VERBOSE
using BoundaryValueDiffEqFIRK
using BoundaryValueDiffEqMIRK
using BoundaryValueDiffEqMIRKN
using BoundaryValueDiffEqShooting
using DiffEqBase: DiffEqBase, solve
using OrdinaryDiffEqTsit5: Tsit5
using Reexport: @reexport
using SciMLBase

@reexport using ADTypes, SciMLBase

function SciMLBase.__init(prob::BVProblem; kwargs...)
    return SciMLBase.__init(prob, Shooting(Tsit5()); kwargs...)
end

function SciMLBase.__solve(prob::BVProblem; kwargs...)
    return SciMLBase.__solve(prob, Shooting(Tsit5()); kwargs...)
end

include("extension_algs.jl")

export MIRK2, MIRK3, MIRK4, MIRK5, MIRK6

export Shooting, MultipleShooting

export RadauIIa1, RadauIIa2, RadauIIa3, RadauIIa5, RadauIIa7
export LobattoIIIa2, LobattoIIIa3, LobattoIIIa4, LobattoIIIa5
export LobattoIIIb2, LobattoIIIb3, LobattoIIIb4, LobattoIIIb5
export LobattoIIIc2, LobattoIIIc3, LobattoIIIc4, LobattoIIIc5

export MIRKN4, MIRKN6

export Ascher1, Ascher2, Ascher3, Ascher4, Ascher5, Ascher6, Ascher7

export BVPM2, BVPSOL, COLNEW # From ODEInterface.jl

export BVPJacobianAlgorithm

export BVPVerbosity, DEFAULT_VERBOSE

export maxsol, minsol

end

using BenchmarkTools
using BoundaryValueDiffEq, OrdinaryDiffEq, NonlinearSolveFirstOrder

include("simple_pendulum.jl")

function create_benchmark()
    suite = BenchmarkGroup()
    suite["Simple Pendulum"] = create_simple_pendulum_benchmark()
    return suite
end

const SUITE = create_benchmark()

@testsetup module ODEInterfaceWrapperTestSetup

using BoundaryValueDiffEq, LinearAlgebra, ODEInterface, Random, RecursiveArrayTools

# Adaptation of https://github.com/luchr/ODEInterface.jl/blob/958b6023d1dabf775033d0b89c5401b33100bca3/examples/BasicExamples/ex7.jl
function ex7_f!(du, u, p, t)
    ϵ = p[1]
    u₁, λ = u
    du[1] = (sin(t)^2 + λ * sin(t)^4 / u₁) / ϵ
    du[2] = 0
    return nothing
end

function ex7_2pbc1!(resa, ua, p)
    resa[1] = ua[1] - 1
    return nothing
end

function ex7_2pbc2!(resb, ub, p)
    resb[1] = ub[1] - 1
    return nothing
end

u0 = [0.5, 1.0]
p = [0.1]
tspan = (-π / 2, π / 2)

export ex7_f!, ex7_2pbc1!, ex7_2pbc2!, u0, p, tspan

end

@testitem "BVPM2" setup = [ODEInterfaceWrapperTestSetup] tags = [:wrappers] skip = true begin
    using ODEInterface, RecursiveArrayTools, LinearAlgebra

    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), u0, tspan,
        p; bcresid_prototype = (zeros(1), zeros(1))
    )

    sol_bvpm2 = solve(tpprob, BVPM2(); dt = π / 20)
    @test SciMLBase.successful_retcode(sol_bvpm2)
    resid_f = (Array{Float64, 1}(undef, 1), Array{Float64, 1}(undef, 1))
    ex7_2pbc1!(resid_f[1], sol_bvpm2(tspan[1]), nothing)
    ex7_2pbc2!(resid_f[2], sol_bvpm2(tspan[2]), nothing)
    @test norm(resid_f, Inf) < 1.0e-6
end

# Just test that it runs. BVPSOL only works with linearly separable BCs.
@testitem "BVPSOL" setup = [ODEInterfaceWrapperTestSetup] tags = [:wrappers] begin
    using ODEInterface, OrdinaryDiffEqTsit5, RecursiveArrayTools, NonlinearSolveFirstOrder

    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), u0, tspan,
        p; bcresid_prototype = (zeros(1), zeros(1))
    )

    # Just generate a solution for bvpsol
    sol_ms = solve(
        tpprob, MultipleShooting(10, Tsit5(), NewtonRaphson());
        dt = π / 20, abstol = 1.0e-5, maxiters = 1000, adaptive = false
    )

    initial_u0 = [sol_ms(t) .+ rand() for t in tspan[1]:(π / 20):tspan[2]]
    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), initial_u0,
        tspan, p; bcresid_prototype = (zeros(1), zeros(1))
    )
    # Just test that it runs. BVPSOL only works with linearly separable BCs.
    sol_bvpsol = solve(tpprob, BVPSOL(); dt = π / 20)

    @test sol_bvpsol isa SciMLBase.ODESolution

    initial_u0 = VectorOfArray([sol_ms(t) .+ rand() for t in tspan[1]:(π / 20):tspan[2]])
    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), initial_u0,
        tspan, p; bcresid_prototype = (zeros(1), zeros(1))
    )
    # Just test that it runs. BVPSOL only works with linearly separable BCs.
    sol_bvpsol = solve(tpprob, BVPSOL(); dt = π / 20)

    @test sol_bvpsol isa SciMLBase.ODESolution

    ts = collect(tspan[1]:(π / 20):tspan[2])
    initial_u0 = DiffEqArray([sol_ms(t) .+ rand() for t in ts], ts)
    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), initial_u0,
        tspan, p; bcresid_prototype = (zeros(1), zeros(1))
    )
    sol_bvpsol = solve(tpprob, BVPSOL(); dt = π / 20)

    @test sol_bvpsol isa SciMLBase.ODESolution

    initial_u0 = (p, t) -> sol_ms(t) .+ rand()
    tpprob = TwoPointBVProblem(
        ex7_f!, (ex7_2pbc1!, ex7_2pbc2!), initial_u0,
        tspan, p; bcresid_prototype = (zeros(1), zeros(1))
    )
    sol_bvpsol = solve(tpprob, BVPSOL(); dt = π / 20)

    @test sol_bvpsol isa SciMLBase.ODESolution
end

@testitem "COLNEW" setup = [ODEInterfaceWrapperTestSetup] tags = [:wrappers] begin
    using ODEInterface, RecursiveArrayTools

    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = u[1]
    end
    function bca!(resid_a, u_a, p)
        resid_a[1] = u_a[1] - 1
    end
    function bcb!(resid_b, u_b, p)
        resid_b[1] = u_b[1]
    end

    fun = BVPFunction(f!, (bca!, bcb!), bcresid_prototype = (zeros(1), zeros(1)), twopoint = Val(true))
    tspan = (0.0, 1.0)

    prob = TwoPointBVProblem(fun, [1.0, 0.0], tspan)
    sol_colnew = solve(prob, COLNEW(), dt = 0.01)
    @test SciMLBase.successful_retcode(sol_colnew)
end

@testitem "COLNEW for multi-points BVP" setup = [ODEInterfaceWrapperTestSetup] tags = [:wrappers] begin
    using ODEInterface, RecursiveArrayTools

    function f!(du, u, p, t)
        du[1] = u[2]
        du[2] = u[3]
        du[3] = u[1] - u[2] + u[3] + t^2 + t
    end

    # just to construct the BVProblem, we don't use it
    function fakebc!(res, u, p, t)
        nothing
    end

    function bc(i, z, bc)
        if i == 1
            bc[1] = z[1]
        elseif i == 2
            bc[1] = z[2] - 1.0
        elseif i == 3
            bc[1] = z[3] + 2.0
        end
    end

    function dbc(i, z, dbc)
        if i == 1
            dbc[1] = 1.0
            dbc[2] = 0.0
            dbc[3] = 0.0
        elseif i == 2
            dbc[1] = 0.0
            dbc[2] = 1.0
            dbc[3] = 0.0
        elseif i == 3
            dbc[1] = 0.0
            dbc[2] = 0.0
            dbc[3] = 1.0
        end
    end

    tspan = (0.0, pi / 2)
    zeta = [0.0, pi / 4, pi / 2]

    prob = BVProblem(f!, fakebc!, [1.0, 1.0, 0.0], tspan)
    sol_colnew = solve(prob, COLNEW(bc_func = bc, dbc_func = dbc, zeta = zeta), dt = 0.01)
    @test SciMLBase.successful_retcode(sol_colnew)
end

@testitem "Initial guess providing" begin
    using BoundaryValueDiffEq, RecursiveArrayTools
    tspan = (0.0, pi / 2)
    function simplependulum!(du, u, p, t)
        θ = u[1]
        dθ = u[2]
        du[1] = dθ
        du[2] = -9.81 * sin(θ)
    end
    function bc!(residual, u, p, t)
        residual[1] = u(pi / 4)[1] + pi / 2
        residual[2] = u(pi / 2)[1] - pi / 2
    end
    u0 = [pi / 2, pi / 2]
    prob = BVProblem(simplependulum!, bc!, u0, tspan)
    sol1 = solve(prob, MIRK4(), dt = 0.05)

    # Solution
    prob1 = BVProblem(simplependulum!, bc!, sol1, tspan)
    sol2 = solve(prob1, MIRK4())
    @test SciMLBase.successful_retcode(sol2)

    sol3 = solve(prob1, RadauIIa5())
    @test SciMLBase.successful_retcode(sol3)

    sol4 = solve(prob1, LobattoIIIa4(nested_nlsolve = true))
    @test SciMLBase.successful_retcode(sol4)

    # VectorOfArray
    prob2 = BVProblem(simplependulum!, bc!, VectorOfArray(sol1.u), tspan)
    sol2 = solve(prob2, MIRK4())
    @test SciMLBase.successful_retcode(sol2)

    sol3 = solve(prob2, RadauIIa5())
    @test SciMLBase.successful_retcode(sol3)

    sol4 = solve(prob2, LobattoIIIa4(nested_nlsolve = true))
    @test SciMLBase.successful_retcode(sol4)
end

# [BoundaryValueDiffEqShooting](@id shooting)

Single shooting method and multiple shooting method. To only use the Shooting methods form BoundaryValueDiffEq.jl, you need to install them use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEqShooting")
```

!!! note "Require OrdinaryDiffEq"
    
    Shooting methods require OrdinaryDiffEq.jl loaded to use the ODE solvers

```julia
solve(prob::BVProblem, alg; kwargs...)
solve(prob::TwoPointBVProblem, alg; kwargs...)
```

Shooting methods should be use together with ODE solvers:

```
BoundaryValueDiffEqShooting.Shooting
BoundaryValueDiffEqShooting.MultipleShooting
```

## Full List of Methods

  - `Shooting`: Single shooting methods, reduces BVP to an initial value problem and solves the IVP.
  - `MultipleShooting`: Reduces BVP to an initial value problem and solves the IVP. Significantly more stable than Single Shooting.

## Detailed Solvers Explanation

```@docs
Shooting
MultipleShooting
```

# [BoundaryValueDiffEqFIRK](@id firk)

Fully Implicit Runge Kutta(FIRK) Methods. To be able to access the solvers in BoundaryValueDiffEqFIRK, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEqFIRK")
```

```julia
solve(prob::BVProblem, alg, dt; kwargs...)
solve(prob::TwoPointBVProblem, alg, dt; kwargs...)
```

## Nested nonlinear solving in FIRK methods

When working with large boundary value problems, especially those involving stiff systems, computational efficiency and solver robustness become critical concerns. To improve the efficiency of FIRK methods on large BVPs, we can use nested nonlinear solving to obtain the implicit FIRK step instead of solving them as part of the global residual. In BoundaryValueDiffEq.jl, we can set `nested_nlsolve` as `true` to enable FIRK methods to compute the implicit FIRK steps using nested nonlinear solving(default option in FIRK methods is `nested_nlsolve=false`).

Moreover, the nested nonlinear problem solver can be finely tuned to meet specific accuracy requirements by providing detailed keyword arguments through the `nested_nlsolve_kwargs` option in any FIRK solver, for example, `RadauIIa5(; nested_nlsolve = true, nested_nlsolve_kwargs = (; abstol = 1e-6, reltol = 1e-6))`, where `nested_nlsolve_kwargs` can be any common keyword arguments in NonlinearSolve.jl, see [Common Solver Options in NonlinearSolve.jl](https://docs.sciml.ai/NonlinearSolve/stable/basics/solve/).

## Full List of Methods

### Radau IIA methods

  - `RadauIIa1`: 1 stage Radau IIA method, without defect control adaptivity
  - `RadauIIa2`: 2 stage Radau IIA method, with defect control adaptivity.
  - `RadauIIa3`: 3 stage Radau IIA method, with defect control adaptivity.
  - `RadauIIa5`: 5 stage Radau IIA method, with defect control adaptivity.
  - `RadauIIa7`: 7 stage Radau IIA method, with defect control adaptivity.

### Lobatto IIIA methods

  - `LobattoIIIa2`: 2 stage Lobatto IIIa method, with defect control adaptivity.
  - `LobattoIIIa3`: 3 stage Lobatto IIIa method, with defect control adaptivity.
  - `LobattoIIIa4`: 4 stage Lobatto IIIa method, with defect control adaptivity.
  - `LobattoIIIa5`: 5 stage Lobatto IIIa method, with defect control adaptivity.

### Lobatto IIIB methods

  - `LobattoIIIb2`: 2 stage Lobatto IIIb method, without defect control adaptivity.
  - `LobattoIIIb3`: 3 stage Lobatto IIIb method, with defect control adaptivity.
  - `LobattoIIIb4`: 4 stage Lobatto IIIb method, with defect control adaptivity.
  - `LobattoIIIb5`: 5 stage Lobatto IIIb method, with defect control adaptivity.

### Lobatto IIIC methods

  - `LobattoIIIc2`: 2 stage Lobatto IIIc method, without defect control adaptivity.
  - `LobattoIIIc3`: 3 stage Lobatto IIIc method, with defect control adaptivity.
  - `LobattoIIIc4`: 4 stage Lobatto IIIc method, with defect control adaptivity.
  - `LobattoIIIc5`: 5 stage Lobatto IIIc method, with defect control adaptivity.

## Detailed Solvers Explanation

```@docs
RadauIIa1
RadauIIa2
RadauIIa3
RadauIIa5
RadauIIa7
```

```@docs
LobattoIIIa2
LobattoIIIa3
LobattoIIIa4
LobattoIIIa5
```

```@docs
LobattoIIIb2
LobattoIIIb3
LobattoIIIb4
LobattoIIIb5
```

```@docs
LobattoIIIc2
LobattoIIIc3
LobattoIIIc4
LobattoIIIc5
```

# [Boundary Value Problems](@id problems)

## The Five Types of Boundary Value Problems

BoundaryValueDiffEq.jl tackles five related types of boundary value problems:

 1. General boundary value problems:, i.e., constraints are applied over the time span. Both overconstraints and underconstraints BVP are supported.
 2. Two-point boundary value problems:, i.e., constraints are only applied at start and end of time span. Both overconstraints and underconstraints BVP are supported.
 3. General second order boundary value problems, i.e., constraints for both solution and derivative of solution are applied over time span. Both overconstraints and underconstraints second order BVP are supported.
 4. Second order two-point boundary value problems, i.e., constraints for both solution and derivative of solution are only applied at the start and end of the time span. Both overconstraints and underconstraints second order BVP are supported.
 5. Boundary value differential algebraic equations, i.e., apart from constraints applied over the time span, BVDAE has additional algebraic equations which state the algebraic relationship of different states in BVDAE.

## Problem Construction Details

```@docs
BVProblem
TwoPointBVProblem
SecondOrderBVProblem
TwoPointSecondOrderBVProblem
```

# [Common Solver Options (Solve Keyword Arguments)](@id solver_options)

  - `abstol::Number`: The absolute tolerance. Defaults to `1e-6`.
  - `adaptive::Bool`: Whether the error control adaptivity is on, default as `true`.
  - `controller`: Error controller for collocation methods, default as `DefectControl()`, more controller options in [Error Control Adaptivity](@ref error_control).
  - `defect_threshold`: Monitor of the size of defect norm. Defaults to `0.1`.
  - `odesolve_kwargs`: OrdinaryDiffEq.jl solvers kwargs for passing to ODE solving in shooting methods. For more information, see the documentation for OrdinaryDiffEq: [Common Solver Options](https://docs.sciml.ai/DiffEqDocs/latest/basics/common_solver_opts/).
  - `nlsolve_kwargs`: NonlinearSolve.jl solvers kwargs for passing to nonlinear solving in collocation methods and shooting methods. For more information, see the documentation for NonlinearSolve: [Common Solver Options](https://docs.sciml.ai/NonlinearSolve/stable/basics/solve/). The default internal nonlinear solver is [customized polyalgorithm](https://github.com/SciML/BoundaryValueDiffEq.jl/blob/master/lib/BoundaryValueDiffEqCore/src/default_nlsolve.jl) and the default absolute tolerance of nonlinear solving in collocation and shooting methods is `1e-6`.
  - `optimize_kwargs`: Optimization.jl solvers kwargs for passing to optimization problem solving in collocation methods and shooting methods. For more information, see the documentation for Optimization: [Common Solver Options](https://docs.sciml.ai/Optimization/stable/API/solve/). The internal optimization solver should be specified and the default absolute tolerance of optimization problem solving in collocation and shooting methods is `1e-6`.
  - `verbose`:  Toggles whether warnings are thrown when the solver exits early. Defaults to `true`.
  - `ensemblealg`: Whether `MultipleShooting` uses multithreading, default as `EnsembleThreads()`. For more information, see the documentation for OrdinaryDiffEq: [EnsembleAlgorithms](https://docs.sciml.ai/DiffEqDocs/latest/features/ensemble/#EnsembleAlgorithms).

# ODEInterface.jl

This is an extension for importing solvers from
[ODEInterface.jl](https://github.com/luchr/ODEInterface.jl) into the SciML
interface. Note that these solvers do not come by default, and thus one needs to install
the package before using these solvers:

```julia
using Pkg
Pkg.add("ODEInterface")
using ODEInterface, BoundaryValueDiffEq
```

## Solver API

```@docs
BVPM2
BVPSOL
COLNEW
```

# Solve Overdetermined and Underdetermined BVP

When there are more or less boundary conditions than the states in a boundary value problem, the BVP would become an overdetermined or underdetermined boundary value problem. As for these kinds of special BVPs, the solving workflow are similar with solving standard BVPs in BoundaryValueDiffEq.jl, but we need to specify the prototype of boundary conditions to tell BoundaryValueDiffEq.jl the structure of our boundary conditions with `bcresid_prototype` in `BVPFunction`.

## Solve Overdetermined BVP

For example, consider an overdetermined BVP given by the system of differential equations

```math
\begin{align*}
y_1' &=  y_2 \\
y_2' &= -y_1
\end{align*}
```

with boundary conditions of

```math
\begin{align*}
y_1(0) &= 0, \\
y_1(100) &= 1, \\
y_2(100) &= -1.729109
\end{align*}
```

The test BVP has two state variables but three boundary conditions, which means there are additional constraints on the solution.

```@example nlls_overdetermined
using BoundaryValueDiffEq, Plots
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = -u[1]
end
function bc!(resid, sol, p, t)
    solₜ₁ = sol(0.0)
    solₜ₂ = sol(100.0)
    resid[1] = solₜ₁[1]
    resid[2] = solₜ₂[1] - 1
    resid[3] = solₜ₂[2] + 1.729109
end
tspan = (0.0, 100.0)
u0 = [0.0, 1.0]
prob = BVProblem(BVPFunction(f!, bc!; bcresid_prototype = zeros(3)), u0, tspan)
sol = solve(prob, MIRK4(), dt = 0.01, abstol = 1e-3)
plot(sol)
```

Since this BVP imposes constraints only at the two endpoints, we can use `TwoPointBVProblem` to handle such cases.

```@example nlls_overdetermined
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = -u[1]
end
bca!(resid, ua, p) = (resid[1] = ua[1])
bcb!(resid, ub, p) = (resid[1] = ub[1] - 1; resid[2] = ub[2] + 1.729109)
bvpfun = BVPFunction(f!, (bca!, bcb!); twopoint = Val(true),
    bcresid_prototype = (zeros(1), zeros(2)))
prob = TwoPointBVProblem(bvpfun, u0, tspan)
```

## Solve Underdetermined BVP

Let's see an example of underdetermined BVP, consider an horizontal metal beam of length $L$ subject to a vertical load $q(x)$ per unit length, the resulting beam displacement satisfies the differential equation

```math
EIy'(x)=q(x)
```

with boundary condition $y(0)=y(L)=0$, $E$ is the Young's modulus and $I$ is the moment of inertia of the beam's cross section. Here we consider the simplified version and transform this BVP into a first order BVP system:

```math
\begin{align*}
y_1' &= y_2\\
y_2' &= y_3\\
y_3' &= y_4\\
y_4' &= 0
\end{align*}
```

```@example nlls_underdetermined
using BoundaryValueDiffEq, Plots
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = u[3]
    du[3] = u[4]
    du[4] = 0
end
function bc!(resid, sol, p, t)
    solₜ₁ = sol(0.0)
    solₜ₂ = sol(1.0)
    resid[1] = solₜ₁[1]
    resid[2] = solₜ₂[1]
end
xspan = (0.0, 1.0)
u0 = [0.0, 1.0, 0.0, 1.0]
prob = BVProblem(BVPFunction(f!, bc!; bcresid_prototype = zeros(2)), u0, xspan)
sol = solve(prob, MIRK4(), dt = 0.01)
plot(sol)
```

Since this problem has less constraints than the state variables, so there would be infinitely many solutions with different `u0` specified.

The above underdetermined is also being able to reformulated as `TwoPointBVProblem`

```@example nlls_underdetermined
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = u[3]
    du[3] = u[4]
    du[4] = 0
end
bca!(resid, ua, p) = (resid[1] = ua[1])
bcb!(resid, ub, p) = (resid[1] = ub[1])
xspan = (0.0, 1.0)
u0 = [0.0, 1.0, 0.0, 1.0]
bvpfun = BVPFunction(f!, (bca!, bcb!); twopoint = Val(true),
    bcresid_prototype = ( zeros(1), zeros(1)))
prob = TwoPointBVProblem(bvpfun, u0, xspan)
```

# Automatic Differentiation Backends

!!! note
    
    We support ForwardDiff.jl, FiniteDiff.jl, Enzyme.jl, Mooncake.jl and PolyesterForwardDiff.jl(PolyesterForwardDiff only for collocation methods) via DifferentiationInterface.jl. Please refer to
    the [backends page](https://juliadiff.org/DifferentiationInterface.jl/DifferentiationInterface/stable/explanation/backends/)
    for more information.

In BoundaryValueDiffEq.jl, automatic differentiation backend should only be wrapped in `BVPJacobianAlgorithm(diffmode, bc_diffmode, nonbc_diffmode)`. `BVPJacobianAlgorithm(diffmode, bc_diffmode, nonbc_diffmode)` supports user-specified mixed automatic differentiation backends in different part of a boundary value problem, and AD choice should depended on the type of boundary value problem:

  - [`BVProblem`](@ref SciMLBase.BVProblem): Differentiation mode for boundary condition part and non boundary condition part should be specified, for example, `BVPJacobianAlgorithm(; bc_diffmode, nonbc_diffmode)`, default to `BVPJacobianAlgorithm(; bc_diffmode = AutoForwardDiff(), nonbc_diffmode = AutoSparse(AutoForwardDiff()))`.
  - [`TwoPointBVProblem`](@ref SciMLBase.TwoPointBVProblem): Differentiation mode for overall solving should be specified, for example, `BVPJacobianAlgorithm(; diffmode)`, default to `BVPJacobianAlgorithm(; diffmode = AutoSparse(AutoForwardDiff()))`.

In BoundaryValueDiffEq.jl, we require AD to obtain the Jacobian of the loss function which contains the collocation equation and boundary condition equations. For `TwoPointBVProblem`, the Jacobian of the loss function is a sparse banded matrix with known sparsity pattern, but for general multi-points `BVProblem`, the Jacobian of the loss function is an almost banded matrix, which has the first several rows as the boundary conditions and the rest as a sparse banded matrix with known sparsity pattern but without the first several rows. In this case, we can specify mixed AD backend in `BVPJacobianAlgorithm` to make the most of the different sparsity pattern to accelerate BVP solving process.

## Summary of Finite Differencing Backends

  - [`AutoFiniteDiff`](@extref ADTypes.AutoFiniteDiff): Finite differencing using
    `FiniteDiff.jl`, not optimal but always applicable.

## Summary of Forward Mode AD Backends

  - [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff): The best choice for dense
    problems.
  - [`AutoPolyesterForwardDiff`](@extref ADTypes.AutoPolyesterForwardDiff): Might be faster
    than [`AutoForwardDiff`](@extref ADTypes.AutoForwardDiff) for large problems. Requires
    `PolyesterForwardDiff.jl` to be installed and loaded.
  - [`AutoEnzyme(; mode = Enzyme.Forward)`](@extref ADTypes.AutoEnzyme): Source transformation forward mode AD.

## Summary of Reverse Mode AD Backends

  - [`AutoEnzyme(; mode = Enzyme.Reverse)`](@extref ADTypes.AutoEnzyme): Source transformation reverse mode AD.
  - [`AutoMooncake(; config = nothing)`](@extref ADTypes.AutoMooncake): Source transformation reverse mode AD.

# Verbosity Control

## Verbosity Specification with SciMLLogging.jl

BoundaryValueDiffEq.jl uses SciMLLogging.jl to provide users with fine-grained control over logging and diagnostic output during BVP solving. The `BVPVerbosity` struct allows you to customize which messages are displayed, from deprecation warnings to detailed debugging information about solver convergence, linear algebra issues, and internal NonlinearSolve.jl/Optimization.jl solver diagnostics.

## Basic Usage

Pass a `BVPVerbosity` object to `solve` or `init` using the `verbose` keyword argument:

```julia
using BoundaryValueDiffEq

# Define a boundary value problem
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = -u[1]
end

function bc!(res, u, p, t)
    res[1] = u[1][1]
    res[2] = u[end][1] - 1
end

u0 = [0.0, 1.0]
tspan = (0.0, 1.0)
prob = BVProblem(f!, bc!, u0, tspan)

# Solve with detailed verbosity to see convergence info
verbose = BVPVerbosity(Detailed())
sol = solve(prob, MIRK4(), dt = 0.1, verbose = verbose)

# Solve with completely silent output (no warnings or deprecations)
sol = solve(prob, MIRK4(), dt = 0.1, verbose = BVPVerbosity(None()))

# Solve with default verbosity (standard preset)
sol = solve(prob, MIRK4(), dt = 0.1)  # equivalent to verbose = BVPVerbosity()
```

## Controlling Internal Solver Verbosity

BoundaryValueDiffEq.jl solvers internally use NonlinearSolve.jl (for nonlinear systems) or Optimization.jl (when using optimization-based methods). You can control the verbosity of these internal solvers independently:

```julia
# Silence BVP messages but show all NonlinearSolve convergence info
verbose = BVPVerbosity(
    None(),
    nonlinear_verbosity = All()
)
sol = solve(prob, MIRK4(), dt = 0.1, verbose = verbose)

# Show standard BVP messages but silence NonlinearSolve output
verbose = BVPVerbosity(
    Standard(),
    nonlinear_verbosity = None()
)
sol = solve(prob, MIRK4(), dt = 0.1, verbose = verbose)

# Control Optimization.jl verbosity when using optimization-based methods
using Optimization, OptimizationOptimJL

verbose = BVPVerbosity(
    Standard(),
    optimization_verbosity = Detailed()
)
sol = solve(prob, MIRK4(optimize = OptimizationOptimJL.BFGS()), dt = 0.1, verbose = verbose)
```

## API Reference

```@docs
BVPVerbosity
```

# [Error Control Adaptivity](@id error_control)

Adaptivity helps ensure the quality of the our numerical solution, and when our solution exhibits significant estimating errors, adaptivity automatically refine the mesh based on the error distribution, and providing a final satisfying solution.

When comes to solving ill-conditioned BVP, for example the singular perturbation problem where the small parameters become extremely small leading to the layers phonemona, the error control adaptivity becomes even more critical, because the minor perturbations can lead to large deviation in the solution. In such cases, adaptivity automatically figure out where to use refined mesh and where to use coarse mesh to achieve the balance of computational efficiency and accuracy.

BoundaryValueDiffEq.jl support error control adaptivity for collocation methods, and the adaptivity is default as defect control adaptivity when using adaptive collocation solvers:

```julia
sol = solve(prob, MIRK4(), dt = 0.01, adaptive = true)
```

Actually, BoundaryValueDiffEq.jl supports both defect and global error control adaptivity(while the defect control is the default controller) [boisvert2013runge](@Citet), to specify different error control methods, we simply need to specify the `controller` keyword in `solve`:

```julia
sol = solve(prob, MIRK4(), dt = 0.01, controller = GlobalErrorControl()) # Use global error control
sol = solve(prob, MIRK4(), dt = 0.01, controller = SequentialErrorControl()) # Use Sequential error control
sol = solve(prob, MIRK4(), dt = 0.01, controller = HybridErrorControl()) # Use Hybrid error control
```

## Error control methods

```@docs
DefectControl
GlobalErrorControl
SequentialErrorControl
HybridErrorControl
NoErrorControl
```

While we can achieve global error control in different ways, we can use different methods to estimate the global error:

```@docs
HOErrorControl
REErrorControl
```

# [BoundaryValueDiffEqMIRKN](@id mirkn)

Monotonic Implicit Runge Kutta Nyström(MIRKN) Methods. To only use the MIRKN methods form BoundaryValueDiffEq.jl, you need to install them use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEqMIRKN")
```

```julia
solve(prob::SecondOrderBVProblem, alg, dt; kwargs...)
solve(prob::TwoPointSecondOrderBVProblem, alg, dt; kwargs...)
```

!!! note "Defect control adaptivity"
    
    MIRKN don't have defect control adaptivity

## Full List of Methods

  - `MIRKN4`: 4 stage Monotonic Implicit Runge-Kutta-Nyström method, with no error control adaptivity.
  - `MIRKN6`: 4 stage Monotonic Implicit Runge-Kutta-Nyström method, with no error control adaptivity.

## Detailed Solvers Explanation

```@docs
MIRKN4
MIRKN6
```

# Get Started with Efficient BVP solving in Julia

When ordinary differential equations has constraints over the time span, we should model the differential equations as a boundary value problem which has the form of:

```math
\frac{du}{dt}=f(u, p, t)\\
g(u(a),u(b))=0
```

BoundaryValueDiffEq.jl addresses three types of BVProblem.

 1. General boundary value problems:, i.e., differential equations with constraints applied over the time span. This is a system where you would like to obtain the solution of the differential equations and make sure the solution satisfy the boundary conditions simutanously.
 2. General second order boundary value problems, i.e., differential equations with constraints for both solution and derivative of solution applied over time span. This is a system where you would like to obtain the solution of the differential equations and make sure the solution satisfy the boundary conditions simutanously.
 3. Boundary value differential-algebraic equations, i.e., apart from constraints applied over the time span, BVDAE has additional algebraic equations which state the algebraic relationship of different states in BVDAE.

## Solving Linear two-point boundary value problem

Consider the linear two-point boundary value problem from [standard BVP test problem](https://archimede.uniba.it/%7Ebvpsolvers/testsetbvpsolvers/?page_id=29).

```@example getting_started
using BoundaryValueDiffEq
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = u[1]
end
function bc!(res, u, p, t)
    res[1] = u(0.0)[1] - 1
    res[2] = u(1.0)[1]
end
tspan = (0.0, 1.0)
u0 = [0.0, 0.0]
prob = BVProblem(f!, bc!, u0, tspan)
sol = solve(prob, MIRK4(), dt = 0.01)
```

Since this problem only has constraints at the start and end of the time span, we can directly use `TwoPointBVProblem`:

```@example getting_started
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = u[1]
end
function bca!(res, ua, p)
    res[1] = ua[1] - 1
end
function bcb!(res, ub, p)
    res[1] = ub[1]
end
tspan = (0.0, 1.0)
u0 = [0.0, 0.0]
prob = TwoPointBVProblem(
    f!, (bca!, bcb!), u0, tspan, bcresid_prototype = (zeros(1), zeros(1)))
sol = solve(prob, MIRK4(), dt = 0.01)
```

## Solving second order boundary value problem

Consirder the test problem from example problems in MIRKN paper [Muir2001MonoImplicitRM](@Citet).

```math
\begin{cases}
y_1'(x) = y_2(x),\\
ε y_2'(x) = -y_1(x) y_2'(x) - y_3(x) y_3'(x),\\
ε y_3'(x) =  y_1'(x) y_3(x) - y_1(x) y_3 '(x)
\end{cases}
```

with initial conditions:

```math
\begin{align*}
y_1(0) &= y_1'(0) = y_1(1)=y_1'(1)=0, \\
y_3(0) &= -1, \\
y_3(1) &=1
\end{align*}
```

```@example getting_started
using BoundaryValueDiffEqMIRKN
function f!(ddu, du, u, p, t)
    ε = 0.1
    ddu[1] = u[2]
    ddu[2] = (-u[1] * du[2] - u[3] * du[3]) / ε
    ddu[3] = (du[1] * u[3] - u[1] * du[3]) / ε
end
function bc!(res, du, u, p, t)
    res[1] = u(0.0)[1]
    res[2] = u(1.0)[1]
    res[3] = u(0.0)[3] + 1
    res[4] = u(1.0)[3] - 1
    res[5] = du(0.0)[1]
    res[6] = du(1.0)[1]
end
u0 = [1.0, 1.0, 1.0]
tspan = (0.0, 1.0)
prob = SecondOrderBVProblem(f!, bc!, u0, tspan)
sol = solve(prob, MIRKN4(), dt = 0.01)
```

## Solving semi-explicit boundary value differential-algebraic equations

Consider the nonlinear semi-explicit DAE of index at most 2 in COLDAE paper [ascher1994collocation](@Citet)

```math
\begin{cases}
x_1' = (ε+ x_2 - \sin(t)) y + \cos(t) \\
x_2' = \cos(t) \\
x_3' = y \\
0 = (x_1-p_1(t)) (y-e^t)
\end{cases}
```

with boundary conditions

```math
\begin{align*}
x_1(0) &= 0, \\
x_3(0) &= 1, \\
x_2(1) &= \sin(1)
\end{align*}
```

```@example getting_started
using BoundaryValueDiffEqAscher
function f!(du, u, p, t)
    du[1] = (1 + u[2] - sin(t)) * u[4] + cos(t)
    du[2] = cos(t)
    du[3] = u[4]
    du[4] = (u[1] - sin(t)) * (u[4] - exp(t))
end
function bc!(res, u, p, t)
    res[1] = u[1]
    res[2] = u[3] - 1
    res[3] = u[2] - sin(1.0)
end
u0 = [0.0, 0.0, 0.0, 0.0]
tspan = (0.0, 1.0)
fun = BVPFunction(f!, bc!, mass_matrix = [1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 0])
prob = BVProblem(fun, u0, tspan)
sol = solve(prob, Ascher4(zeta = [0.0, 0.0, 1.0]), dt = 0.01)
```

# Solve BVP with Extremum Boundary Conditions

In many physical systems, boundary conditions are not always defined at fixed points such as initial or terminal ends of the domain. Instead, we may encounter scenarios where constraints are imposed on the maximum or minimum values that the solution must attain somewhere within the domain. In such cases, we can use the `maxsol` and `minsol` functions provided by BoundaryValueDiffEq.jl to specify such extremum boundary conditions.

Let's walk through this functionality with an intuitive example. We still revisit the simple pendulum example here, but this time, suppose we need to impose the maximum and minimum value to our boundary conditions, specified as:

```math
\max{u}=ub\\
\min{u}=lb
```

where `lb=-4.8161991710010925` and `ub=5.0496477654230745`. So the states must conform that the maximum value of the state should be `lb` while the minimum value of the state should be `ub`. To solve such problems, we can simply use the `maxsol` and `minsol` functions when defining the boundary value problem in BoundaryValueDiffEq.jl.

```@example inequality
using BoundaryValueDiffEq, Plots
tspan = (0.0, pi / 2)
function simplependulum!(du, u, p, t)
    θ = u[1]
    dθ = u[2]
    du[1] = dθ
    du[2] = -9.81 * sin(θ)
end
function bc!(residual, u, p, t)
    residual[1] = maxsol(u, (0.0, pi / 2)) - 5.0496477654230745
    residual[2] = minsol(u, (0.0, pi / 2)) + 4.8161991710010925
end
prob = BVProblem(simplependulum!, bc!, [pi / 2, pi / 2], tspan)
sol = solve(prob, MIRK4(), dt = 0.05)
plot(sol)
```

# [SimpleBoundaryValueDiffEq](@id simpleboundaryvaluediffeq)

## Full List of Methods

```julia
SimpleBoundaryValueDiffEq.SimpleMIRK4
SimpleBoundaryValueDiffEq.SimpleMIRK5
SimpleBoundaryValueDiffEq.SimpleMIRK6
SimpleBoundaryValueDiffEq.SimpleShooting
```

# [BoundaryValueDiffEqAscher](@id ascher)

Gauss Legendre collocation methods with Ascher's error control adaptivity and mesh refinement routines. To be able to access the solvers in BoundaryValueDiffEqFIRK, you must first install them use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEqAscher")
```

```julia
solve(prob::BVProblem, alg, dt; kwargs...)
solve(prob::TwoPointBVProblem, alg, dt; kwargs...)
```

## Full List of Methods

  - `Ascher1`: 1 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher2`: 2 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher3`: 3 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher4`: 4 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher5`: 5 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher6`: 6 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.
  - `Ascher7`: 7 stage Gauss Legendre collocation method with Ascher's error control adaptivity and mesh refinement.

## Detailed Solvers Explanation

```@docs
Ascher1
Ascher2
Ascher3
Ascher4
Ascher5
Ascher6
Ascher7
```

# Estimate Unknown Parameters in BVP

When there are unknown parameters in boundary value problems, we can estimate the unknown parameters by solving the BVP, it is quite useful in practical applications in dynamical optimizations and inverse problems. This approach allows us to incorporate both the governing differential equations and boundary conditions to infer parameters that may not be directly measurable.

Let's walk through this functionality with an intuitive example. In the following tutorial, we use the [Mathieu equation](https://en.wikipedia.org/wiki/Mathieu_wavelet) which is a second-order differential equation:

```math
y''+(\lambda-2q\cos(2x))y=0
```

where $\lambda$ is the unknown parameter we wish to estimate, `q` is a known real-valued parameter, with boundary conditions when `q=5`:

```math
y'(0)=0,\ y'(\pi)=0
```

The second-order BVP can be transformed into a first-order system of BVP:

```math
\begin{cases}
y_1'=y_2\\
y_2'=-(\lambda-2q\cos(2x))y_1
\end{cases}
```

with boundary conditions of

```math
y_2(0)=0,\ y_2(\pi)=0
```

It is worthnoting that in this system, while we have two differetial equations, it isn't enough to estimate the unknown parameters and guarantee a unique numerical solution with only two given boundary conditions. While under the hood, the parameters are estimated simultaneously with the numerical solution, it makes the boundary value problem an underconstrained BVP if the number of constraints are equal to the number of states, which may result in more than one solution. So we should provide additional constraint $y(0)=1$ from the original equation to make sure unique numerical solution and the estimated parameters are we actually wanted.

With BoundaryValueDiffEq.jl, it's easy to solve boundary value problems with unknown parameters, we can just specify `tune_parameters=true` when constructing the BVP and provide the guess of the unknown parameters in `prob.p`, for example, to estimate the unknown parameters in the above BVP system:

```@example unknown
using BoundaryValueDiffEq, Plots
tspan = (0.0, pi)
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = -(p[1] - 10 * cos(2 * t)) * u[1]
end
function bca!(res, u, p)
    res[1] = u[2]
    res[2] = u[1] - 1.0
end
function bcb!(res, u, p)
    res[1] = u[2]
end
guess(p, t) = [cos(4t); -4sin(4t)]
bvp = TwoPointBVProblem(f!, (bca!, bcb!), guess, tspan, [15.0],
    bcresid_prototype = (zeros(2), zeros(1)), tune_parameters = true)
sol = solve(bvp, MIRK4(), dt = 0.05)
plot(sol)
```

after solving the boundary value problem, the estimated unknown parameters can be accessed in the solution

```@example unknown
sol.prob.p
```

# Solve BVP with Continuation

Continuation is a commonly used technique for solving numerically difficult boundary value problems, we exploit the priori knowledge of the solution as initial guess to accelerate the BVP solving by breaking up the difficult BVP into a sequence of simpler problems. For example, we use the problem from [ascher1995numerical](@Citet) in this tutorial:

```math
ε y'' + xy' = ε \pi^2\cos(\pi x) - \pi x\sin(\pi x)
```

for ``ε = 10^{-4}``, on ``t\in[-1,1]`` with two point boundary conditions ``y(-1)=-2``, ``y(1)=0``. With analytical solution of ``y(x) = \cos(\pi x) + \operatorname{erf}(x/\sqrt{2ε})/\operatorname{erf}(1/\sqrt{2ε})``, this problem has a rapid transition layer at ``x=0``, making it difficult to solve numerically. In this tutorial, we will showcase how to use continuation with BoundaryValueDiffEq.jl to solve this BVP.

We use the substitution to transform this problem into a first order BVP system:

```math
\begin{align*}
y_1'&= y_2 \\
y_2'&= -\frac{x}{ε} y_2 - \pi^2\cos(\pi x) - \frac{\pi x}{ε} \sin(\pi x)
\end{align*}
```

Since this BVP would become difficult to solve when ``0<ε\ll 1``, we start the continuation with relatively bigger ``ε`` to first obtain a good initial guess for cases when $\epsilon$ are becoming extremely small. We can just use the previous solution from BVP solving as the initial guess `u0` when constructing a new `BVProblem`.

```@example continuation
using BoundaryValueDiffEq, Plots
function f!(du, u, p, t)
    du[1] = u[2]
    du[2] = -t / p * u[2] - pi^2 * cospi(t) - pi * t / p * sinpi(t)
end
function bc!(res, u, p, t)
    res[1] = u[1][1] + 2
    res[2] = u[end][1]
end
tspan = (-1.0, 1.0)
sol = [1.0, 0.0]
e = 0.1
for i in 2:4
    global e = e / 10
    prob = BVProblem(f!, bc!, sol, tspan, e)
    global sol = solve(prob, MIRK4(), dt = 0.01)
end
plot(sol, idxs = [1])
```

In the iterative solving, the intermediate solutions are each used as the initial guess for the next problem solving.

## On providing initial guess

There are several ways of providing initial guess in `BVProblem`/`TwoPointBVProblem`:

 1. Solution from BVP/ODE solving from SciML packages with `ODESolution` type.
 2. `VectorOfArray` from RecursiveArrayTools.jl.
 3. `DiffEqArray` from RecursiveArrayTools.jl.
 4. Function handle of the form `f(p, t)` for specifying initial guess on time span.
 5. `AbstractArray` represent only the possible initial condition.

# [BVP Functions and Jacobian Types](@id bvpfunctions)

The SciML ecosystem provides an extensive interface for declaring extra functions associated with the boundary value probems's data. In traditional libraries, there is usually only few options: the Jacobian and the Jacobian of boundary conditions. However, we allow for a large array of pre-computed functions to speed up the calculations. This is offered via the `BVPFunction` types, which can be passed to the problems.

## Function Type Definitions

```@docs
SciMLBase.BVPFunction
SciMLBase.DynamicalBVPFunction
```

# BoundaryValueDiffEq.jl: High-Performance Boundary Value Problem Solvers

BoundaryValueDiffEq.jl is a component package in the DifferentialEquations.jl ecosystem.
The package includes its own high-performance BVP solvers which covers wide range of different kinds boundary value problems, includes the ability to swap out to fast direct and iterative nonlinear solvers, along with the ability to use sparse
automatic differentiation for Jacobian construction and Jacobian-vector products.

## Installation

To install BoundaryValueDiffEq.jl, use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEq")
```

## Contributing

  - Please refer to the
    [SciML ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://github.com/SciML/ColPrac/blob/master/README.md)
    for guidance on PRs, issues, and other matters relating to contributing to SciML.

  - See the [SciML Style Guide](https://github.com/SciML/SciMLStyle) for common coding practices and other style decisions.
  - There are a few community forums:
    
      + The #diffeq-bridged and #sciml-bridged channels in the [Julia Slack](https://julialang.org/slack/)
      + The #diffeq-bridged and #sciml-bridged channels in the [Julia Zulip](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
      + On the [Julia Discourse forums](https://discourse.julialang.org)
      + See also [SciML Community page](https://sciml.ai/community/)

## Reproducibility

```@raw html
<details><summary>The documentation of this SciML package was built using these direct dependencies,</summary>
```

```@example
using Pkg # hide
Pkg.status() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>and using this machine and Julia version.</summary>
```

```@example
using InteractiveUtils # hide
versioninfo() # hide
```

```@raw html
</details>
```

```@raw html
<details><summary>A more complete overview of all dependencies and their versions is also provided.</summary>
```

```@example
using Pkg # hide
Pkg.status(; mode = PKGMODE_MANIFEST) # hide
```

```@raw html
</details>
```

```@eval
using TOML
using Markdown
version = TOML.parse(read("../../Project.toml", String))["version"]
name = TOML.parse(read("../../Project.toml", String))["name"]
link_manifest = "https://github.com/SciML/" *
                name *
                ".jl/tree/gh-pages/v" *
                version *
                "/assets/Manifest.toml"
link_project = "https://github.com/SciML/" *
               name *
               ".jl/tree/gh-pages/v" *
               version *
               "/assets/Project.toml"
Markdown.parse("""You can also download the
[manifest]($link_manifest)
file and the
[project]($link_project)
file.
""")
```

# Solve Dynamical Optimization problem

BoundaryValueDiffEq.jl is capable of solving dynamical optimization problems via collocation solvers. The syntax for solving with BoundaryValueDiffEq.jl is quite different from JuMP-style optimization modeling DSL.

To model such optimal control problem is more similar to solve an boundary value problem, we only need to further provide the cost functional within `BVPFunction`. In the following content, we will explain the detailed usage of BoundaryValueDiffEq.jl in dynamical optimization with some hands-on examples.

## Block Move Optimal Control

Block move optimal control problem is an easy example of optimal control problem [kelly2017introduction](@Citet), this problem models moving a small block between two points, starting and finishing at rest, in a fixed amount of time.

### System dynamics

Suppose we apply the external force $f$ on a block which can slide without friction in one dimension, its position $x$ and velocity $v$ can be described using:

```math
\left\{\begin{aligned}
&\frac{dx}{dt}=v\\
&\frac{dv}{dt}=f
\end{aligned}\right.
```

Since the presence of control variables $f$, we can pass our state variables and control variables together as `[state variables, control variables]`, which is `u = [x, v, f]` in the system dynamics:

```julia
function block_move!(du, u, p, t)
    x, v, f = u[1], u[2], u[3]
    du[1] = v
    du[2] = f
end
```

To tell solvers the difference between state variables and control variables, `f_prototype` must be explicitly specified in `BVPFunction`, for example, we have 2 state variables and 1 control variable, so `f_prototype = zeros(2)`.

### Boundary Constraints

The block moves from $x = -1$ at time $t = 0$ to $x = 0$ at time $t = 1$, starting and finishing at rest:

```math
x(0)=-1.0, v(0)=0, x(1)=0, v(1)=0
```

So the boundary conditions are:

```julia
function block_move_bc!(res, u, p, t)
    res[1] = u(0.0)[1] + 1.0
    res[2] = u(0.0)[2]
    res[3] = u(1.0)[1]
    res[4] = u(1.0)[2]
end
```

### Cost functional

We want to minimize the total energy during the whole process, so the cost functional is an integral of the applied force(Lagrange form):

```math
\min_{x(t),v(t),f(t)} \frac{1}{2}\int_0^1 u^2(\tau)d\tau
```

The cost functional should be defined following the interpolating style in boundary conditions, for example, use `sol(t₁)` to interpolate at `t=t₁`. Here, to express the integral cost function, we can directly use `integral(f, domain)` to integrate the integrand:

```julia
cost_fun(sol, p) = 0.5*integral((t, p) -> sol(t)[3]^2, (0.0, 1.0))
```

As for other cost functional which need the interpolation of some exact points of the solution(Mayer form), we only need to define an OOP cost function that interpolating the solution at the specific point, for example:

```@example block_move
cost_fun(sol, p) = sol(1.0)[3]
```

### State and Control bounds

Block move optimal control problem with minimized energy desn't require lower and upper bounds, so we can just specify `lb = [-Inf, -Inf, -Inf]` and `ub = [Inf, Inf, Inf]`.

### Initial guess

The initial guess of the dynamical optimization problem must be provided, either as the initial guess of the first state, `u0 = [-1.0, 0.0, 6.0]` or initial guess function of the whole solution such as `u0(t, p) = [sin(t), cos(t), sin(t)]`.

With all the above parts, we can build the model for our block move optimal control example:
So the copy-and-paste code for the block move optimal control problem is:

```julia
using BoundaryValueDiffEqMIRK, OptimizationIpopt
#cost_fun(sol, p) = 0.5*sum(reduce(hcat, sol.u)[3, :] .^ 2)*0.005
cost_fun(sol, p) = 0.5*integral((t, p) -> sol(t)[3]^2, (0.0, 1.0))
function block_move!(du, u, p, t)
    x, v, f = u[1], u[2], u[3]
    du[1] = v
    du[2] = f
end
function block_move_bc!(res, u, p, t)
    res[1] = u(0.0)[1] + 1.0
    res[2] = u(0.0)[2]
    res[3] = u(1.0)[1]
    res[4] = u(1.0)[2]
end
tspan = (0.0, 1.0)
u0 = [-1.0, 0.0, 6.0]
block_move_fun = BVPFunction(block_move!, block_move_bc!; cost = cost_fun,
    f_prototype = zeros(2), bcresid_prototype = zeros(4))
block_move_prob = BVProblem(
    block_move_fun, u0, tspan; lb = [-Inf, -Inf, -Inf], ub = [Inf, Inf, Inf])
sol = solve(block_move_prob, MIRK4(; optimize = IpoptOptimizer()), dt = 0.002, adaptive = false)
```

## Rocket Launching Optimal Control

Another classical optimal control problem is the rocket launching problem(aka [Goddard Rocket problem](https://en.wikipedia.org/wiki/Goddard_problem)). Say we have a rocket with limited fuel and is launched vertically. And we want to control the final altitude of this rocket so that we can make the best of the limited fuel in rocket to get to the highest altitude. In this optimal control problem, the state variables are:

  - Velocity of the rocket: $x_v(t)$
  - Altitude of the rocket: $x_h(t)$
  - Mass of the rocket and the fuel: $x_m(t)$

The control variable is

  - Thrust of the rocket: $u_t(t)$

The dynamics of the launching can be formulated with three differential equations:

```math
\left\{\begin{aligned}
&\frac{dx_v}{dt}=\frac{u_t-drag(x_h,x_v)}{x_m}-g(x_h)\\
&\frac{dx_h}{dt}=x_v\\
&\frac{dx_m}{dt}=-\frac{u_t}{c}
\end{aligned}\right.
```

where the drag $D(x_h,x_v)$ is a function of altitude and velocity:

```math
D(x_h,x_v)=D_c\cdot x_v^2\cdot\exp^{h_c(\frac{x_h-x_h(0)}{x_h(0)})}
```

gravity $g(x_h)$ is a function of altitude:

```math
g(x_h)=g_0\cdot (\frac{x_h(0)}{x_h})^2
```

$c$ is a constant. Suppose the final time is $T$, we here want to maximize the final altitude $x_h(T)$:

```math
\max x_h(T)
```

The inequality constraints for the state variables and control variables are:

```math
\left\{\begin{aligned}
&x_v>0\\
&x_h>0\\
&m_T<x_m<m_0\\
&0<u_t<u_{t\text{max}}
\end{aligned}\right.
```

Similar solving for such optimal control problem can be found on JuMP.jl and InfiniteOpt.jl. The detailed parameters are taken from [COPS](https://www.mcs.anl.gov/%7Emore/cops/cops3.pdf).

```@example rocket_launch
using BoundaryValueDiffEqMIRK, OptimizationIpopt, Plots
h_0 = 1                      # Initial height
v_0 = 0                      # Initial velocity
m_0 = 1.0                    # Initial mass
m_T = 0.6                    # Final mass
g_0 = 1                      # Gravity at the surface
h_c = 500                    # Used for drag
c = 0.5 * sqrt(g_0 * h_0)    # Thrust-to-fuel mass
D_c = 0.5 * 620 * m_0 / g_0  # Drag scaling
u_t_max = 3.5 * g_0 * m_0    # Maximum thrust
T_max = 0.2                  # Number of seconds
T = 1_000                    # Number of time steps
Δt = 0.2 / T;                # Time per discretized step

tspan = (0.0, 0.2)
drag(x_h, x_v) = D_c * x_v^2 * exp(-h_c * (x_h - h_0) / h_0)
g(x_h) = g_0 * (h_0 / x_h)^2
function rocket_launch!(du, u, p, t)
    # u_t is the control variable (thrust)
    x_v, x_h, x_m, u_t = u[1], u[2], u[3], u[4]
    du[1] = (u_t-drag(x_h, x_v))/x_m - g(x_h)
    du[2] = x_v
    du[3] = -u_t/c
end
function rocket_launch_bc!(res, u, p, t)
    res[1] = u(0.0)[1] - v_0
    res[2] = u(0.0)[2] - h_0
    res[3] = u(0.0)[3] - m_0
    res[4] = u(0.2)[4] - 0.0
end
cost_fun(u, p) = -u(0.2)[2]
u0 = [v_0, h_0, m_T, 3.0]
rocket_launch_fun = BVPFunction(rocket_launch!, rocket_launch_bc!; cost = cost_fun, f_prototype = zeros(3))
rocket_launch_prob = BVProblem(
    rocket_launch_fun, u0, tspan; lb = [0.0, h_0, m_T, 0.0], ub = [Inf, Inf, m_0, u_t_max])
sol = solve(rocket_launch_prob, MIRK4(; optimize = IpoptOptimizer()); dt = Δt, adaptive = false)

u = reduce(hcat, sol.u)
v, h, m, c = u[1, :], u[2, :], u[3, :], u[4, :]

# Plot the solution
p1 = plot(sol.t, v, xlabel = "Time", ylabel = "Velocity", legend = false)
p2 = plot(sol.t, h, xlabel = "Time", ylabel = "Altitude", legend = false)
p3 = plot(sol.t, m, xlabel = "Time", ylabel = "Mass", legend = false)
p4 = plot(sol.t, c, xlabel = "Time", ylabel = "Thrust", legend = false)

plot(p1, p2, p3, p4, layout = (2, 2))
savefig("rocket_launch.png"); nothing # hide
```

![](rocket_launch.png)

Similar optimal control problem solving can also be deployed in JuMP.jl and InfiniteOpt.jl.

## Cart-Pole Optimal Control

The dynamic equation of the motion of cart-pole swing-up problem are given by:

```math

\begin{bmatrix}
\ddot{x} \\
\ddot{\theta}
\end{bmatrix}

\begin{bmatrix}
\cos\theta & \ell \\
m_1 + m_2 & m_2 \ell \cos\theta
\end{bmatrix}^{-1}
\begin{bmatrix}

  - g \sin\theta \\
    F + m_2 \ell \dot{\theta}^2 \sin\theta
    \end{bmatrix}
```

where $x$ is the location of the cart, $\theta$ is the pole angle, $m_1$ is the cart mass, $m_2$ is the pole mass, $l$ is the pole length.

By converting the dynamics to first order equations, we can get the formulation:

```math
\begin{bmatrix}
\dot{x} \\
\dot{\theta} \\
\ddot{x} \\
\ddot{\theta} \\
\dot{e}
\end{bmatrix}

f\!\left(
\begin{bmatrix}
x \\ \theta \\ \dot{x} \\ \dot{\theta} \\ e
\end{bmatrix}
\right)

\begin{bmatrix}
\dot{x} \\
\dot{\theta} \\
\dfrac{-m_2 g \sin\theta \cos\theta - \left(F + m_2 \ell \dot{\theta}^2 \sin\theta\right)}
{m_2 \cos^2\theta - (m_1 + m_2)} \\
\dfrac{(m_1 + m_2) g \sin\theta + \cos\theta \left(F + m_2 \ell \dot{\theta}^2 \sin\theta\right)}
{m_2 \ell \cos^2\theta - (m_1 + m_2)\ell} \\
F^2
\end{bmatrix}
```

and the initial conditions of all states at $t=0$ are all zero, the boundary conditions at time $t_f$ are:

```math
x_f=d, \dot{x_f}=0, \theta_f=\pi, \dot{\theta_f}=0
```

The target cost function is defined as the "energy" so the target cost function is:

```math
\min J=\int\dot{e}dt=F
```

```@example cart_pole
using BoundaryValueDiffEqMIRK, OptimizationIpopt, Plots
m_1 = 1.0                      # Cart mass
m_2 = 0.3                      # Pole mass
l = 0.5                        # Pole length
d = 2.0                        # Cart target location
t_0 = 0.0                      # Start time
t_f = 2.0                      # Final time
g = 9.81                       # Gravity constant
tspan = (t_0, t_f)
function cart_pole!(du, u, p, t)
    x, θ, dx, dθ, f = u[1], u[2], u[3], u[4], u[5]
    du[1] = dx
    du[2] = dθ
    du[3] = (- m_2*g*sin(θ)*cos(θ) - (f + m_2*l*θ^2*sin(θ))) / (m_2*l*cos(θ)^2 - m_1 - m_2)
    du[4] = ((m_1 + m_2)*g*sin(θ) + cos(θ)*(f + m_1*l*dθ^2*sin(θ))) /
            (m_2*l*cos(θ)^2 - (m_1 + m_2)*l)
end

function cart_pole_bc!(du, u, p, t)
    du[1] = u(t_f)[1] - d
    du[2] = u(t_f)[2] - π
    du[3] = u(t_0)[2] - 0.0
    du[4] = u(t_0)[3] - 0.0
    du[5] = u(t_0)[4] - 0.0
    du[6] = u(t_f)[3] - 0.0
    du[7] = u(t_f)[4] - 0.0
end
cost_fun(u, p) = u(t_f)[5]
u0 = [0.0, 0.0, 0.0, 0.0, 10.0]
cart_pole_fun = BVPFunction(cart_pole!, cart_pole_bc!; cost = cost_fun,
    bcresid_prototype = zeros(7), f_prototype = zeros(4))
cart_pole_prob = BVProblem(cart_pole_fun, u0, tspan; lb = [-2.0, -Inf, -Inf, -Inf, -20.0],
    ub = [2.0, Inf, Inf, Inf, 20.0])
sol = solve(cart_pole_prob, MIRK4(; optimize = IpoptOptimizer()); dt = 0.01, adaptive = false)

t = sol.t
x, theta, dx, dtheta, f = sol[1, :], sol[2, :], sol[3, :], sol[4, :], sol[5, :]

L = 1.0    # pole length (visual)
cart_w = 0.4    # cart width
cart_h = 0.2    # cart height

# Precompute pole tip coordinates
px = x .+ L .* sin.(theta)
py = cart_h/2 .- L .* cos.(theta)

# Axis limits (a bit margin around the cart trajectory)
xmin = minimum(x) - 2L
xmax = maximum(x) + 2L
ymin = -2.0
ymax = 2.0

anim = @animate for k in eachindex(t)
    cart_x = x[k]
    pole_x = px[k]
    pole_y = py[k]

    # Base plot / axis
    plot(; xlim = (xmin, xmax), ylim = (ymin, ymax), aspect_ratio = :equal,
        legend = false, title = "Cart–Pole (t = $(round(t[k], digits=2)) s)")

    # Draw ground
    plot!([xmin, xmax], [0, 0], lw = 2, color = :black)

    # Draw cart as a rectangle
    rect = Shape(
        [cart_x - cart_w/2, cart_x + cart_w/2, cart_x + cart_w/2, cart_x - cart_w/2],
        [0, 0, cart_h, cart_h])
    plot!(rect, color = :gray)

    # Draw pole as a line from cart center to tip
    plot!([cart_x, pole_x], [cart_h/2, pole_y], lw = 3, color = :red)

    # Draw pivot point
    scatter!([cart_x], [cart_h/2], ms = 4, color = :black)
end

# Save GIF
gif(anim, "../assets/cart_pole.gif", fps = 40)
```

# [BoundaryValueDiffEqMIRK](@id mirk)

Monotonic Implicit Runge Kutta(MIRK) Methods. To only use the MIRK methods form BoundaryValueDiffEq.jl, you need to install them use the Julia package manager:

```julia
using Pkg
Pkg.add("BoundaryValueDiffEqMIRK")
```

```julia
solve(prob::BVProblem, alg, dt; kwargs...)
solve(prob::TwoPointBVProblem, alg, dt; kwargs...)
```

## Full List of Methods

  - `MIRK2`: 2 stage Monotonic Implicit Runge-Kutta method, with defect control adaptivity.
  - `MIRK3`: 3 stage Monotonic Implicit Runge-Kutta method, with defect control adaptivity.
  - `MIRK4`: 4 stage Monotonic Implicit Runge-Kutta method, with defect control adaptivity.
  - `MIRK5`: 5 stage Monotonic Implicit Runge-Kutta method, with defect control adaptivity.
  - `MIRK6`: 6 stage Monotonic Implicit Runge-Kutta method, with defect control adaptivity.

## Detailed Solvers Explanation

```@docs
MIRK2
MIRK3
MIRK4
MIRK5
MIRK6
```

# [Wrapper Methods](@id wrapper)

!!! note "Require ODEInterface"
    
    Wrapper methods require ODEInterface.jl loaded

```julia
solve(prob::BVProblem, alg; kwargs...)
solve(prob::TwoPointBVProblem, alg; kwargs...)
```

## Full List of Methods

  - BVPM2: Single shooting methods, reduces BVP to an initial value problem and solves the IVP.
  - BVPSOL: Reduces BVP to an initial value problem and solves the IVP. Significantly more stable than Single Shooting.
  - COLNEW: Gauss-Legendre collocation methods for BVP with Ascher's error control adaptivity and mesh refinement.
